From 7bb973db094f26b112aa4114ca8ad6d317ad6348 Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Thu, 4 May 2017 12:58:41 +0530
Subject: [PATCH 01/37] qcacld-3.0: Update proper status for disable roam cmd

Currently, for disable roam from supplicant, if STA is in
not connected state, driver wont send any commands to FW
as it is unnecessary. However, for this case, driver updates
fail status to supplicant.

Update success status for disable roam cmd when STA is
in not connected state.

Change-Id: I076d1b5389868b5d136e5adce730f6b3ec41e6f8
CRs-Fixed: 2042596
---
 core/hdd/src/wlan_hdd_cfg80211.c |    6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

diff --git a/core/hdd/src/wlan_hdd_cfg80211.c b/core/hdd/src/wlan_hdd_cfg80211.c
index 9f3a361..98d983c 100644
--- a/core/hdd/src/wlan_hdd_cfg80211.c
+++ b/core/hdd/src/wlan_hdd_cfg80211.c
@@ -8818,6 +8818,7 @@ static int __wlan_hdd_cfg80211_set_fast_roaming(struct wiphy *wiphy,
 	int ret;
 	QDF_STATUS qdf_status;
 	unsigned long rc;
+	hdd_station_ctx_t *hdd_sta_ctx = WLAN_HDD_GET_STATION_CTX_PTR(adapter);
 
 	ENTER_DEV(dev);
 
@@ -8863,9 +8864,10 @@ static int __wlan_hdd_cfg80211_set_fast_roaming(struct wiphy *wiphy,
 				qdf_status);
 	ret = qdf_status_to_os_return(qdf_status);
 
-	INIT_COMPLETION(adapter->lfr_fw_status.disable_lfr_event);
-	if (QDF_IS_STATUS_SUCCESS(qdf_status) && !enable_lfr_fw) {
+	if (eConnectionState_Associated == hdd_sta_ctx->conn_info.connState &&
+		QDF_IS_STATUS_SUCCESS(qdf_status) && !enable_lfr_fw) {
 
+		INIT_COMPLETION(adapter->lfr_fw_status.disable_lfr_event);
 		/*
 		 * wait only for LFR disable in fw as LFR enable
 		 * is always success
-- 
1.7.9.5


From fcacc38172d05affe20745cd76e0e085395a4529 Mon Sep 17 00:00:00 2001
From: Deepak Dhamdhere <ddhamdhe@codeaurora.org>
Date: Thu, 20 Apr 2017 17:59:58 -0700
Subject: [PATCH 02/37] qcacld-3.0: Use correct smeSessionid in rrm beacon
 report xmit

lim_send_radio_measure_report_action_frame() uses 0 as the smeSessionId
and that results in wrong value of vdev_id when firmware vdev is 1,
resulting in firmware assert. Use the value from sme session entry.

CRs-Fixed: 2036670
Change-Id: I797a719abc29d4086be131f895a90e0752a2d27f
---
 core/mac/src/pe/lim/lim_send_management_frames.c |    2 ++
 1 file changed, 2 insertions(+)

diff --git a/core/mac/src/pe/lim/lim_send_management_frames.c b/core/mac/src/pe/lim/lim_send_management_frames.c
index 75935b3..3d01cfb 100644
--- a/core/mac/src/pe/lim/lim_send_management_frames.c
+++ b/core/mac/src/pe/lim/lim_send_management_frames.c
@@ -4131,6 +4131,8 @@ lim_send_radio_measure_report_action_frame(tpAniSirGlobal pMac,
 		return eSIR_FAILURE;
 	}
 
+	smeSessionId = psessionEntry->smeSessionId;
+
 	pe_debug("dialog_token %d num_report %d",
 			dialog_token, num_report);
 
-- 
1.7.9.5


From f5f22a3fb3861bb7ba4911df02b0a20e372886d8 Mon Sep 17 00:00:00 2001
From: Agrawal Ashish <ashishka@codeaurora.org>
Date: Tue, 9 May 2017 17:24:39 +0530
Subject: [PATCH 03/37] qcacld-3.0: Don't update MBO IEs twice

Driver should not send MBO IEs if MBO Ies come from supplicant.

Change-Id: I7ad27759ba2454465f3e204d207cb58eaf8804a9
CRs-Fixed: 2044567
---
 core/hdd/src/wlan_hdd_scan.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/core/hdd/src/wlan_hdd_scan.c b/core/hdd/src/wlan_hdd_scan.c
index e4ca4b4..617827b 100644
--- a/core/hdd/src/wlan_hdd_scan.c
+++ b/core/hdd/src/wlan_hdd_scan.c
@@ -1526,7 +1526,7 @@ static int wlan_hdd_update_scan_ies(hdd_adapter_t *adapter,
 				add_ie = true;
 			break;
 		case IE_EID_VENDOR:
-			if ((0 == qdf_mem_cmp(&temp_ie[0], MBO_OUI_TYPE,
+			if ((0 != qdf_mem_cmp(&temp_ie[0], MBO_OUI_TYPE,
 							MBO_OUI_TYPE_SIZE)) ||
 				(0 == qdf_mem_cmp(&temp_ie[0], QCN_OUI_TYPE,
 							QCN_OUI_TYPE_SIZE)))
-- 
1.7.9.5


From f97ae22c5d4f23d69922bd391ab626be113ff49a Mon Sep 17 00:00:00 2001
From: bings <bings@codeaurora.org>
Date: Tue, 9 May 2017 05:54:55 +0800
Subject: [PATCH 04/37] qcacld-3.0: Refine HTC service connection for HTT in
 different platforms

Different HTC services should be connected based on different platforms.
HTT_DATA(2/3)_MSG_SVC are needed in ihelium, while only HTT_DATA_MSG_SVC
is needed in Rome/TF.

Change-Id: Ic36b191cd6d94255148ae6a47356ce2a149e78df
CRs-Fixed: 2043082
---
 core/dp/htt/htt.c |   38 +++++++++++++++++++++++++++++++++-----
 1 file changed, 33 insertions(+), 5 deletions(-)

diff --git a/core/dp/htt/htt.c b/core/dp/htt/htt.c
index 0cbc6e2..fe0940a 100644
--- a/core/dp/htt/htt.c
+++ b/core/dp/htt/htt.c
@@ -320,6 +320,38 @@ void htt_clear_bundle_stats(htt_pdev_handle pdev)
 }
 #endif
 
+#if defined(QCA_WIFI_3_0_ADRASTEA)
+/**
+ * htt_htc_attach_all() - Connect to HTC service for HTT
+ * @pdev: pdev ptr
+ *
+ * Return: 0 for success or error code.
+ */
+static int
+htt_htc_attach_all(struct htt_pdev_t *pdev)
+{
+	if (htt_htc_attach(pdev, HTT_DATA_MSG_SVC))
+		return -EIO;
+	if (htt_htc_attach(pdev, HTT_DATA2_MSG_SVC))
+		return -EIO;
+	if (htt_htc_attach(pdev, HTT_DATA3_MSG_SVC))
+		return -EIO;
+	return 0;
+}
+#else
+/**
+ * htt_htc_attach_all() - Connect to HTC service for HTT
+ * @pdev: pdev ptr
+ *
+ * Return: 0 for success or error code.
+ */
+static int
+htt_htc_attach_all(struct htt_pdev_t *pdev)
+{
+	return htt_htc_attach(pdev, HTT_DATA_MSG_SVC);
+}
+#endif
+
 /**
  * htt_pdev_alloc() - allocate HTT pdev
  * @txrx_pdev: txrx pdev
@@ -391,11 +423,7 @@ htt_pdev_alloc(ol_txrx_pdev_handle txrx_pdev,
 	 * since htt_rx_attach involves sending a rx ring configure
 	 * message to the target.
 	 */
-	if (htt_htc_attach(pdev, HTT_DATA_MSG_SVC))
-		goto htt_htc_attach_fail;
-	if (htt_htc_attach(pdev, HTT_DATA2_MSG_SVC))
-		goto htt_htc_attach_fail;
-	if (htt_htc_attach(pdev, HTT_DATA3_MSG_SVC))
+	if (htt_htc_attach_all(pdev))
 		goto htt_htc_attach_fail;
 	if (hif_ce_fastpath_cb_register(osc, htt_t2h_msg_handler_fast, pdev))
 		qdf_print("failed to register fastpath callback\n");
-- 
1.7.9.5


From 1f428861ad26d567dde55f656a233d323bc72ea7 Mon Sep 17 00:00:00 2001
From: Dhanashri Atre <datre@codeaurora.org>
Date: Wed, 3 May 2017 14:56:10 -0700
Subject: [PATCH 05/37] qcacld-3.0: Fix spinlock being unlocked twice

Fix the spinlock being unlocked twice while enqueuing buffers
in the peer buffer queue.

Change-Id: I42e3a638e1789765a5103b4b775fc2d9a7822181
CRs-Fixed: 2041873
---
 core/dp/txrx/ol_txrx.c |   43 ++++++++++++++++++++++++++-----------------
 1 file changed, 26 insertions(+), 17 deletions(-)

diff --git a/core/dp/txrx/ol_txrx.c b/core/dp/txrx/ol_txrx.c
index f9822a1..5420561 100644
--- a/core/dp/txrx/ol_txrx.c
+++ b/core/dp/txrx/ol_txrx.c
@@ -4776,6 +4776,23 @@ free_buf:
 /* print for every 16th packet */
 #define OL_TXRX_PRINT_RATE_LIMIT_THRESH 0x0f
 
+/** helper function to drop packets
+ *  Note: caller must hold the cached buq lock before invoking
+ *  this function. Also, it assumes that the pointers passed in
+ *  are valid (non-NULL)
+ */
+static inline void ol_txrx_drop_frames(
+					struct ol_txrx_cached_bufq_t *bufqi,
+					qdf_nbuf_t rx_buf_list)
+{
+	uint32_t dropped = ol_txrx_drop_nbuf_list(rx_buf_list);
+	bufqi->dropped += dropped;
+	bufqi->qdepth_no_thresh += dropped;
+
+	if (bufqi->qdepth_no_thresh > bufqi->high_water_mark)
+		bufqi->high_water_mark = bufqi->qdepth_no_thresh;
+}
+
 static QDF_STATUS ol_txrx_enqueue_rx_frames(
 					struct ol_txrx_peer_t *peer,
 					struct ol_txrx_cached_bufq_t *bufqi,
@@ -4783,8 +4800,6 @@ static QDF_STATUS ol_txrx_enqueue_rx_frames(
 {
 	struct ol_rx_cached_buf *cache_buf;
 	qdf_nbuf_t buf, next_buf;
-	QDF_STATUS status = QDF_STATUS_SUCCESS;
-	int dropped = 0;
 	static uint32_t count;
 
 	if ((count++ & OL_TXRX_PRINT_RATE_LIMIT_THRESH) == 0)
@@ -4794,8 +4809,9 @@ static QDF_STATUS ol_txrx_enqueue_rx_frames(
 
 	qdf_spin_lock_bh(&bufqi->bufq_lock);
 	if (bufqi->curr >= bufqi->thresh) {
-		status = QDF_STATUS_E_FAULT;
-		goto drop_bufs;
+		ol_txrx_drop_frames(bufqi, rx_buf_list);
+		qdf_spin_unlock_bh(&bufqi->bufq_lock);
+		return QDF_STATUS_E_FAULT;
 	}
 	qdf_spin_unlock_bh(&bufqi->bufq_lock);
 
@@ -4812,32 +4828,25 @@ static QDF_STATUS ol_txrx_enqueue_rx_frames(
 			/* Add NULL terminator */
 			qdf_nbuf_set_next(buf, NULL);
 			cache_buf->buf = buf;
-			qdf_spin_lock_bh(&bufqi->bufq_lock);
 			if (peer && peer->valid) {
+				qdf_spin_lock_bh(&bufqi->bufq_lock);
 				list_add_tail(&cache_buf->list,
 				      &bufqi->cached_bufq);
 				bufqi->curr++;
 				qdf_spin_unlock_bh(&bufqi->bufq_lock);
 			} else {
-				status = QDF_STATUS_E_FAULT;
 				qdf_mem_free(cache_buf);
 				rx_buf_list = buf;
 				qdf_nbuf_set_next(rx_buf_list, next_buf);
-				goto drop_bufs;
+				qdf_spin_lock_bh(&bufqi->bufq_lock);
+				ol_txrx_drop_frames(bufqi, rx_buf_list);
+				qdf_spin_unlock_bh(&bufqi->bufq_lock);
+				return QDF_STATUS_E_FAULT;
 			}
 		}
 		buf = next_buf;
 	}
-
-drop_bufs:
-	dropped = ol_txrx_drop_nbuf_list(rx_buf_list);
-	bufqi->dropped += dropped;
-	bufqi->qdepth_no_thresh += dropped;
-
-	if (bufqi->qdepth_no_thresh > bufqi->high_water_mark)
-		bufqi->high_water_mark = bufqi->qdepth_no_thresh;
-	qdf_spin_unlock_bh(&bufqi->bufq_lock);
-	return status;
+	return QDF_STATUS_SUCCESS;
 }
 /**
  * ol_rx_data_process() - process rx frame
-- 
1.7.9.5


From c35bf075b0f900225773e63363b721645b331955 Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Thu, 11 May 2017 16:50:15 +0530
Subject: [PATCH 06/37] qcacld-3.0: Update channel info if not provided in
 FASTREASSOC command

Currently, driver is rejecting the FASTREASSOC command if the channel
is not provided as part of it (or) channel is given as zero.

Update channel from BSS description of the given BSS and honour
the FASTREASSOC command even if the channel is given zero.

Change-Id: Ie67a75fb7ccf470b95454842b7f46baa9b09d54c
CRs-Fixed: 2046547
---
 core/hdd/src/wlan_hdd_ioctl.c |    9 +++++----
 core/sme/inc/sme_api.h        |    4 +++-
 core/sme/src/common/sme_api.c |   10 ++++++++--
 3 files changed, 16 insertions(+), 7 deletions(-)

diff --git a/core/hdd/src/wlan_hdd_ioctl.c b/core/hdd/src/wlan_hdd_ioctl.c
index c853bf1..15f0974 100644
--- a/core/hdd/src/wlan_hdd_ioctl.c
+++ b/core/hdd/src/wlan_hdd_ioctl.c
@@ -840,7 +840,6 @@ void hdd_wma_send_fastreassoc_cmd(hdd_adapter_t *adapter,
 		return;
 	}
 	fastreassoc->vdev_id = adapter->sessionId;
-	fastreassoc->channel = channel;
 	fastreassoc->bssid[0] = bssid[0];
 	fastreassoc->bssid[1] = bssid[1];
 	fastreassoc->bssid[2] = bssid[2];
@@ -850,8 +849,10 @@ void hdd_wma_send_fastreassoc_cmd(hdd_adapter_t *adapter,
 
 	status = sme_get_beacon_frm(WLAN_HDD_GET_HAL_CTX(adapter), profile,
 						bssid, &fastreassoc->frame_buf,
-						&fastreassoc->frame_len);
+						&fastreassoc->frame_len,
+						&channel);
 
+	fastreassoc->channel = channel;
 	if (QDF_STATUS_SUCCESS != status) {
 		hdd_warn("sme_get_beacon_frm failed");
 		fastreassoc->frame_buf = NULL;
@@ -4445,8 +4446,8 @@ static int drv_cmd_fast_reassoc(hdd_adapter_t *adapter,
 	}
 
 	/* Check channel number is a valid channel number */
-	if (QDF_STATUS_SUCCESS !=
-		wlan_hdd_validate_operation_channel(adapter, channel)) {
+	if (channel && (QDF_STATUS_SUCCESS !=
+		wlan_hdd_validate_operation_channel(adapter, channel))) {
 		hdd_err("Invalid Channel [%d]", channel);
 		return -EINVAL;
 	}
diff --git a/core/sme/inc/sme_api.h b/core/sme/inc/sme_api.h
index c1ce085..e5c9c66 100644
--- a/core/sme/inc/sme_api.h
+++ b/core/sme/inc/sme_api.h
@@ -1510,12 +1510,14 @@ QDF_STATUS sme_get_rcpi(tHalHandle hal, struct sme_rcpi_req *rcpi);
  * @bssid: bssid to look for in scan cache
  * @frame_buf: frame buffer to populate
  * @frame_len: length of constructed frame
+ * @channel: Pointer to channel info to be filled
  *
  * Return: QDF_STATUS
  */
 QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 			    const tSirMacAddr bssid,
-			    uint8_t **frame_buf, uint32_t *frame_len);
+			    uint8_t **frame_buf, uint32_t *frame_len,
+			    int *channel);
 
 /**
  * sme_rso_cmd_status_cb() - Set RSO cmd status callback
diff --git a/core/sme/src/common/sme_api.c b/core/sme/src/common/sme_api.c
index 81e8335..dad4d68 100644
--- a/core/sme/src/common/sme_api.c
+++ b/core/sme/src/common/sme_api.c
@@ -17408,7 +17408,8 @@ static void sme_prepare_beacon_from_bss_descp(uint8_t *frame_buf,
 }
 QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 				const tSirMacAddr bssid,
-				uint8_t **frame_buf, uint32_t *frame_len)
+				uint8_t **frame_buf, uint32_t *frame_len,
+				int *channel)
 {
 	QDF_STATUS status = QDF_STATUS_SUCCESS;
 	tScanResultHandle result_handle = NULL;
@@ -17428,6 +17429,7 @@ QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 						profile, scan_filter);
 	if (QDF_STATUS_SUCCESS != status) {
 		sme_err("prepare_filter failed");
+		status = QDF_STATUS_E_FAULT;
 		goto free_scan_flter;
 	}
 
@@ -17448,6 +17450,7 @@ QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 	status = csr_scan_get_result(mac_ctx, scan_filter, &result_handle);
 	if (QDF_STATUS_SUCCESS != status) {
 		sme_err("parse_scan_result failed");
+		status = QDF_STATUS_E_FAULT;
 		goto free_scan_flter;
 	}
 
@@ -17465,7 +17468,8 @@ QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 	 */
 	ie_len = bss_descp->length - sizeof(tSirBssDescription)
 		+ sizeof(bss_descp->length) + sizeof(bss_descp->ieFields);
-	sme_debug("found bss_descriptor ie_len: %d", ie_len);
+	sme_debug("found bss_descriptor ie_len: %d channel %d",
+					ie_len, bss_descp->channelId);
 
 	/* include mac header and fixed params along with IEs in frame */
 	*frame_len = SIR_MAC_HDR_LEN_3A + SIR_MAC_B_PR_SSID_OFFSET + ie_len;
@@ -17478,6 +17482,8 @@ QDF_STATUS sme_get_beacon_frm(tHalHandle hal, tCsrRoamProfile *profile,
 	qdf_mem_zero(*frame_buf, *frame_len);
 	sme_prepare_beacon_from_bss_descp(*frame_buf, bss_descp, bssid, ie_len);
 
+	if (!*channel)
+		*channel = bss_descp->channelId;
 free_scan_flter:
 	/* free scan filter and exit */
 	if (scan_filter) {
-- 
1.7.9.5


From 6acbcac2cb5a8b7c87c83c8322d1a534b48ab165 Mon Sep 17 00:00:00 2001
From: Ashwini Patil <apati@codeaurora.org>
Date: Wed, 17 May 2017 20:53:07 +0530
Subject: [PATCH 07/37] qcacld-3.0: Update current_bss in kernel after roaming
 to candidate AP

After roaming to candiadate AP, bssid is not updated in kernel
because of passing invalid arguments to ieee80211_get_channel()
and cfg80211_get_bss(). This is resulting into failure of
action frames(after reassoc) in kernel with error ENOTCONN.
So, correct the parameters for these two functions.

Change-Id: I803accb18510e3f033456ed2ff2b4f9e3a4baf33
---
 core/hdd/src/wlan_hdd_assoc.c |   25 +++++++++++++++++++++----
 core/hdd/src/wlan_hdd_main.c  |    4 ++--
 2 files changed, 23 insertions(+), 6 deletions(-)

diff --git a/core/hdd/src/wlan_hdd_assoc.c b/core/hdd/src/wlan_hdd_assoc.c
index 449909f..35f4bd8 100644
--- a/core/hdd/src/wlan_hdd_assoc.c
+++ b/core/hdd/src/wlan_hdd_assoc.c
@@ -1906,6 +1906,8 @@ static void hdd_send_re_assoc_event(struct net_device *dev,
 	uint8_t *final_req_ie = NULL;
 	tCsrRoamConnectedProfile roam_profile;
 	tHalHandle hal_handle = WLAN_HDD_GET_HAL_CTX(pAdapter);
+	int chan_no;
+	int freq;
 
 	qdf_mem_zero(&roam_profile, sizeof(roam_profile));
 
@@ -1963,8 +1965,14 @@ static void hdd_send_re_assoc_event(struct net_device *dev,
 	qdf_mem_copy(rspRsnIe, pFTAssocRsp, len);
 	qdf_mem_zero(rspRsnIe + len, IW_GENERIC_IE_MAX - len);
 
-	chan = ieee80211_get_channel(pAdapter->wdev.wiphy,
-			(int)pCsrRoamInfo->pBssDesc->channelId);
+	chan_no = pCsrRoamInfo->pBssDesc->channelId;
+	if (chan_no <= 14)
+		freq = ieee80211_channel_to_frequency(chan_no,
+						      NL80211_BAND_2GHZ);
+	else
+		freq = ieee80211_channel_to_frequency(chan_no,
+						      NL80211_BAND_5GHZ);
+	chan = ieee80211_get_channel(pAdapter->wdev.wiphy, freq);
 	sme_roam_get_connect_profile(hal_handle, pAdapter->sessionId,
 		&roam_profile);
 
@@ -2279,6 +2287,8 @@ static QDF_STATUS hdd_association_completion_handler(hdd_adapter_t *pAdapter,
 	bool hddDisconInProgress = false;
 	unsigned long rc;
 	tSirResultCodes timeout_reason = 0;
+	int chan_no;
+	int freq;
 
 	if (!pHddCtx) {
 		hdd_err("HDD context is NULL");
@@ -2528,11 +2538,18 @@ static QDF_STATUS hdd_association_completion_handler(hdd_adapter_t *pAdapter,
 								 pAdapter->sessionId);
 						hdd_debug("ft_carrier_on is %d, sending roamed indication",
 							 ft_carrier_on);
+
+						chan_no = pRoamInfo->pBssDesc->channelId;
+						if (chan_no <= 14)
+							freq = ieee80211_channel_to_frequency(chan_no,
+								  NL80211_BAND_2GHZ);
+						else
+							freq = ieee80211_channel_to_frequency(chan_no,
+								  NL80211_BAND_5GHZ);
 						chan =
 							ieee80211_get_channel
 								(pAdapter->wdev.wiphy,
-								(int)pRoamInfo->pBssDesc->
-								channelId);
+								 freq);
 						hdd_debug(
 							"assocReqlen %d assocRsplen %d",
 							assocReqlen,
diff --git a/core/hdd/src/wlan_hdd_main.c b/core/hdd/src/wlan_hdd_main.c
index 83dac08..5a97be5 100644
--- a/core/hdd/src/wlan_hdd_main.c
+++ b/core/hdd/src/wlan_hdd_main.c
@@ -4019,8 +4019,8 @@ struct cfg80211_bss *hdd_cfg80211_get_bss(struct wiphy *wiphy,
 {
 	return cfg80211_get_bss(wiphy, channel, bssid,
 				ssid, ssid_len,
-				WLAN_CAPABILITY_ESS,
-				WLAN_CAPABILITY_ESS);
+				IEEE80211_BSS_TYPE_ESS,
+				IEEE80211_PRIVACY_ANY);
 }
 #else
 struct cfg80211_bss *hdd_cfg80211_get_bss(struct wiphy *wiphy,
-- 
1.7.9.5


From bd9ab3a34ca29b099f225dbb0d319f08f3880a37 Mon Sep 17 00:00:00 2001
From: Kapil Gupta <kapgupta@codeaurora.org>
Date: Tue, 9 May 2017 13:50:39 +0530
Subject: [PATCH 08/37] qcacld-3.0: Add changes to add MBO IE in assoc request

Add changes to add support for unpacking of MBO IE in association
request packet.

Change-Id: I575f718b0804e679bab31432694c97e45bd87ca0
CRs-Fixed: 2044512
---
 core/mac/src/cfg/cfgUtil/dot11f.frms           |    1 +
 core/mac/src/include/dot11f.h                  |    3 ++-
 core/mac/src/sys/legacy/src/utils/src/dot11f.c |    5 ++++-
 3 files changed, 7 insertions(+), 2 deletions(-)

diff --git a/core/mac/src/cfg/cfgUtil/dot11f.frms b/core/mac/src/cfg/cfgUtil/dot11f.frms
index 05bb351..07167ec 100644
--- a/core/mac/src/cfg/cfgUtil/dot11f.frms
+++ b/core/mac/src/cfg/cfgUtil/dot11f.frms
@@ -3267,6 +3267,7 @@ FRAME AssocRequest                        // 7.2.3.4
     OPTIE  WFDIEOpaque;
     OPTIE  vendor_vht_ie;
     OPTIE  hs20vendor_ie;
+    OPTIE  MBO_IE;
     OPTIE  QCN_IE;
 } // End frame AssocRequest.
 
diff --git a/core/mac/src/include/dot11f.h b/core/mac/src/include/dot11f.h
index 1911410..e31733b 100644
--- a/core/mac/src/include/dot11f.h
+++ b/core/mac/src/include/dot11f.h
@@ -35,7 +35,7 @@
  *
  *
  * This file was automatically generated by 'framesc'
- * Mon Apr 17 17:06:15 2017 from the following file(s):
+ * Tue May  9 13:47:22 2017 from the following file(s):
  *
  * dot11f.frms
  *
@@ -8368,6 +8368,7 @@ typedef struct sDot11fAssocRequest{
 	tDot11fIEWFDIEOpaque                  WFDIEOpaque;
 	tDot11fIEvendor_vht_ie                vendor_vht_ie;
 	tDot11fIEhs20vendor_ie                hs20vendor_ie;
+	tDot11fIEMBO_IE                       MBO_IE;
 	tDot11fIEQCN_IE                       QCN_IE;
 } tDot11fAssocRequest;
 
diff --git a/core/mac/src/sys/legacy/src/utils/src/dot11f.c b/core/mac/src/sys/legacy/src/utils/src/dot11f.c
index fdf493a..bc0fc22 100644
--- a/core/mac/src/sys/legacy/src/utils/src/dot11f.c
+++ b/core/mac/src/sys/legacy/src/utils/src/dot11f.c
@@ -33,7 +33,7 @@
  *
  *
  * This file was automatically generated by 'framesc'
- * Mon Apr 17 17:06:15 2017 from the following file(s):
+ * Tue May  9 13:47:22 2017 from the following file(s):
  *
  * dot11f.frms
  *
@@ -6643,6 +6643,9 @@ static const tIEDefn IES_AssocRequest[] = {
 	offsetof(tDot11fIEhs20vendor_ie, present), 0, "hs20vendor_ie",
 	0, 7, 9, SigIehs20vendor_ie, {80, 111, 154, 16, 0},
 	4, DOT11F_EID_HS20VENDOR_IE, 0, 0, },
+	{ offsetof(tDot11fAssocRequest, MBO_IE), offsetof(tDot11fIEMBO_IE,
+	present), 0, "MBO_IE", 0, 9, 12, SigIeMBO_IE, {80, 111, 154, 22, 0},
+	4, DOT11F_EID_MBO_IE, 0, 0, },
 	{ offsetof(tDot11fAssocRequest, QCN_IE), offsetof(tDot11fIEQCN_IE,
 	present), 0, "QCN_IE", 0, 10, 10, SigIeQCN_IE, {140, 253, 240, 1, 0},
 	4, DOT11F_EID_QCN_IE, 0, 0, },
-- 
1.7.9.5


From 82d7b2916f9533aa805c7306289ac9ab795c812b Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Thu, 4 May 2017 14:50:08 +0530
Subject: [PATCH 09/37] qcacld-3.0: Send RSO Start followed by RSO Stop for
 supplicant disabled roam

Currently, if supplicant disabled roaming, driver doesnot send RSO
cmd to fw. This causes roam invoke to fail in FW since RSO start
never happened at least once to configure roaming engine in FW.

After connection, Send RSO start followed by RSO Stop if supplicant
disabled roaming to make sure roaming engine in FW is configured
properly with required parameters at least once.

Change-Id: I72b73554b03ea3f0fa04d0da2a2db96c0ed8b1c8
CRs-Fixed: 2042629
---
 core/sme/inc/csr_neighbor_roam.h     |    2 ++
 core/sme/src/csr/csr_api_roam.c      |    6 ------
 core/sme/src/csr/csr_neighbor_roam.c |   11 +++++++++++
 3 files changed, 13 insertions(+), 6 deletions(-)

diff --git a/core/sme/inc/csr_neighbor_roam.h b/core/sme/inc/csr_neighbor_roam.h
index 586d4d2..ba39d22 100644
--- a/core/sme/inc/csr_neighbor_roam.h
+++ b/core/sme/inc/csr_neighbor_roam.h
@@ -325,6 +325,8 @@ void csr_roam_reset_roam_params(tpAniSirGlobal mac_ptr);
 #define REASON_ROAM_SCAN_STA_ROAM_POLICY_CHANGED    35
 #define REASON_ROAM_SYNCH_FAILED                    36
 #define REASON_ROAM_PSK_PMK_CHANGED                 37
+#define REASON_ROAM_STOP_ALL                        38
+#define REASON_SUPPLICANT_DISABLED_ROAMING          39
 
 
 #if defined(WLAN_FEATURE_HOST_ROAM) || defined(WLAN_FEATURE_ROAM_OFFLOAD)
diff --git a/core/sme/src/csr/csr_api_roam.c b/core/sme/src/csr/csr_api_roam.c
index 188eece..97c59a1 100644
--- a/core/sme/src/csr/csr_api_roam.c
+++ b/core/sme/src/csr/csr_api_roam.c
@@ -18522,12 +18522,6 @@ csr_roam_offload_scan(tpAniSirGlobal mac_ctx, uint8_t session_id,
 		return QDF_STATUS_E_FAILURE;
 	}
 
-	if ((ROAM_SCAN_OFFLOAD_START == command) &&
-	    (session->pCurRoamProfile &&
-	     session->pCurRoamProfile->do_not_roam)) {
-		sme_debug("Supplicant disabled driver roaming");
-		return QDF_STATUS_E_FAILURE;
-	}
 	if (0 == csr_roam_is_roam_offload_scan_enabled(mac_ctx)) {
 		sme_err("isRoamOffloadScanEnabled not set");
 		return QDF_STATUS_E_FAILURE;
diff --git a/core/sme/src/csr/csr_neighbor_roam.c b/core/sme/src/csr/csr_neighbor_roam.c
index 4d50f27..9373b69 100644
--- a/core/sme/src/csr/csr_neighbor_roam.c
+++ b/core/sme/src/csr/csr_neighbor_roam.c
@@ -1042,9 +1042,20 @@ static void csr_neighbor_roam_info_ctx_init(
 			}
 		} else
 #endif
+
 			csr_roam_offload_scan(pMac, session_id,
 				ROAM_SCAN_OFFLOAD_START,
 				REASON_CONNECT);
+
+			if (session->pCurRoamProfile &&
+				 session->pCurRoamProfile->do_not_roam) {
+				sme_debug("Supplicant disabled driver roaming");
+
+				csr_roam_offload_scan(pMac, session_id,
+					ROAM_SCAN_OFFLOAD_STOP,
+					REASON_SUPPLICANT_DISABLED_ROAMING);
+			}
+
 	}
 }
 
-- 
1.7.9.5


From 3ea0ae9abcf90f6999f4ba765b61b86d38c7a296 Mon Sep 17 00:00:00 2001
From: Himanshu Agarwal <himanaga@codeaurora.org>
Date: Mon, 8 May 2017 14:39:35 +0530
Subject: [PATCH 10/37] qcacld-3.0: Fix implementation of some datapath
 functions

Fix implementation of some datapath functions by:
1) Change the return value of ol_tx_prepare_ll() from
   msdu list to tx desc.
2) Pass pointer of msdu info instead of msdu info structure
   in ol_tx_encap_wrapper().

Change-Id: Ibd091800e152288e6ca218416e8629879ef4839d
CRs-Fixed: 2043747
---
 core/dp/txrx/ol_tx.c |  105 ++++++++++++++++++++++++++++++++------------------
 1 file changed, 68 insertions(+), 37 deletions(-)

diff --git a/core/dp/txrx/ol_tx.c b/core/dp/txrx/ol_tx.c
index c12d72b..6236d5a 100644
--- a/core/dp/txrx/ol_tx.c
+++ b/core/dp/txrx/ol_tx.c
@@ -70,24 +70,31 @@ int ce_send_fast(struct CE_handle *copyeng, qdf_nbuf_t msdu,
  * succeeds, that guarantees that the target has room to accept
  * the new tx frame.
  */
-#define ol_tx_prepare_ll(tx_desc, vdev, msdu, msdu_info)		\
-	do {								\
-		struct ol_txrx_pdev_t *pdev = vdev->pdev;		\
-		(msdu_info)->htt.info.frame_type = pdev->htt_pkt_type;	\
-		tx_desc = ol_tx_desc_ll(pdev, vdev, msdu, msdu_info);	\
-		if (qdf_unlikely(!tx_desc)) {				\
-			/*						\
-			 * If TSO packet, free associated		\
-			 * remaining TSO segment descriptors		\
-			 */						\
-			if (qdf_nbuf_is_tso(msdu))			\
-				ol_free_remaining_tso_segs(		\
-					vdev, msdu_info, true);		\
-			TXRX_STATS_MSDU_LIST_INCR(			\
-				pdev, tx.dropped.host_reject, msdu);	\
-			return msdu; /* the list of unaccepted MSDUs */	\
-		}							\
-	} while (0)
+static struct ol_tx_desc_t *
+ol_tx_prepare_ll(ol_txrx_vdev_handle vdev,
+		 qdf_nbuf_t msdu,
+		 struct ol_txrx_msdu_info_t *msdu_info)
+{
+	struct ol_tx_desc_t *tx_desc;
+	struct ol_txrx_pdev_t *pdev = vdev->pdev;
+
+	(msdu_info)->htt.info.frame_type = pdev->htt_pkt_type;
+	tx_desc = ol_tx_desc_ll(pdev, vdev, msdu, msdu_info);
+	if (qdf_unlikely(!tx_desc)) {
+		/*
+		 * If TSO packet, free associated
+		 * remaining TSO segment descriptors
+		 */
+		if (qdf_nbuf_is_tso(msdu))
+			ol_free_remaining_tso_segs(
+					vdev, msdu_info, true);
+		TXRX_STATS_MSDU_LIST_INCR(
+				pdev, tx.dropped.host_reject, msdu);
+		return NULL;
+	}
+
+	return tx_desc;
+}
 
 #if defined(FEATURE_TSO)
 void ol_free_remaining_tso_segs(ol_txrx_vdev_handle vdev,
@@ -423,7 +430,9 @@ qdf_nbuf_t ol_tx_ll(ol_txrx_vdev_handle vdev, qdf_nbuf_t msdu_list)
 
 			segments--;
 
-			ol_tx_prepare_ll(tx_desc, vdev, msdu, &msdu_info);
+			tx_desc = ol_tx_prepare_ll(vdev, msdu, &msdu_info);
+			if (!tx_desc)
+				return msdu;
 
 			/**
 			* if this is a jumbo nbuf, then increment the number
@@ -485,7 +494,9 @@ qdf_nbuf_t ol_tx_ll(ol_txrx_vdev_handle vdev, qdf_nbuf_t msdu_list)
 
 		msdu_info.htt.info.ext_tid = qdf_nbuf_get_tid(msdu);
 		msdu_info.peer = NULL;
-		ol_tx_prepare_ll(tx_desc, vdev, msdu, &msdu_info);
+		tx_desc = ol_tx_prepare_ll(vdev, msdu, &msdu_info);
+		if (!tx_desc)
+			return msdu;
 
 		TXRX_STATS_MSDU_INCR(vdev->pdev, tx.from_stack, msdu);
 
@@ -1279,7 +1290,9 @@ ol_tx_non_std_ll(ol_txrx_vdev_handle vdev,
 		msdu_info.peer = NULL;
 		msdu_info.tso_info.is_tso = 0;
 
-		ol_tx_prepare_ll(tx_desc, vdev, msdu, &msdu_info);
+		tx_desc = ol_tx_prepare_ll(vdev, msdu, &msdu_info);
+		if (!tx_desc)
+			return msdu;
 
 		/*
 		 * The netbuf may get linked into a different list inside the
@@ -1319,20 +1332,34 @@ ol_tx_non_std_ll(ol_txrx_vdev_handle vdev,
 }
 
 #ifdef QCA_SUPPORT_SW_TXRX_ENCAP
-#define OL_TX_ENCAP_WRAPPER(pdev, vdev, tx_desc, msdu, tx_msdu_info) \
-	do { \
-		if (OL_TX_ENCAP(vdev, tx_desc, msdu, &tx_msdu_info) != A_OK) { \
-			qdf_atomic_inc(&pdev->tx_queue.rsrc_cnt); \
-			ol_tx_desc_frame_free_nonstd(pdev, tx_desc, 1);	\
-			if (tx_msdu_info.peer) { \
-				/* remove the peer reference added above */ \
-				OL_TXRX_PEER_UNREF_DELETE(tx_msdu_info.peer); \
-			} \
-			goto MSDU_LOOP_BOTTOM; \
-		} \
-	} while (0)
+static inline int ol_tx_encap_wrapper(struct ol_txrx_pdev_t *pdev,
+				      ol_txrx_vdev_handle vdev,
+				      struct ol_tx_desc_t *tx_desc,
+				      qdf_nbuf_t msdu,
+				      struct ol_txrx_msdu_info_t *tx_msdu_info)
+{
+	if (OL_TX_ENCAP(vdev, tx_desc, msdu, tx_msdu_info) != A_OK) {
+		qdf_atomic_inc(&pdev->tx_queue.rsrc_cnt);
+		ol_tx_desc_frame_free_nonstd(pdev, tx_desc, 1);
+		if (tx_msdu_info->peer) {
+			/* remove the peer reference added above */
+			OL_TXRX_PEER_UNREF_DELETE(tx_msdu_info->peer);
+		}
+		return -EINVAL;
+	}
+
+	return 0;
+}
 #else
-#define OL_TX_ENCAP_WRAPPER(pdev, vdev, tx_desc, msdu, tx_msdu_info) /* no-op */
+static inline int ol_tx_encap_wrapper(struct ol_txrx_pdev_t *pdev,
+				      ol_txrx_vdev_handle vdev,
+				      struct ol_tx_desc_t *tx_desc,
+				      qdf_nbuf_t msdu,
+				      struct ol_txrx_msdu_info_t *tx_msdu_info)
+{
+	/* no-op */
+	return 0;
+}
 #endif
 
 /* tx filtering is handled within the target FW */
@@ -1816,8 +1843,9 @@ ol_tx_hl_base(
 			 * encap, it performs encap, and if an error is
 			 * encountered, jumps to the MSDU_LOOP_BOTTOM label.
 			 */
-			OL_TX_ENCAP_WRAPPER(pdev, vdev, tx_desc, msdu,
-					    tx_msdu_info);
+			if (ol_tx_encap_wrapper(pdev, vdev, tx_desc, msdu,
+						&tx_msdu_info))
+				goto MSDU_LOOP_BOTTOM;
 
 			/* initialize the HW tx descriptor */
 			htt_tx_desc_init(
@@ -2091,7 +2119,10 @@ qdf_nbuf_t ol_tx_reinject(struct ol_txrx_vdev_t *vdev,
 	msdu_info.htt.action.tx_comp_req = 0;
 	msdu_info.tso_info.is_tso = 0;
 
-	ol_tx_prepare_ll(tx_desc, vdev, msdu, &msdu_info);
+	tx_desc = ol_tx_prepare_ll(vdev, msdu, &msdu_info);
+	if (!tx_desc)
+		return msdu;
+
 	HTT_TX_DESC_POSTPONED_SET(*((uint32_t *) (tx_desc->htt_tx_desc)), true);
 
 	htt_tx_desc_set_peer_id(tx_desc->htt_tx_desc, peer_id);
-- 
1.7.9.5


From a95ad3ddbbd3949777a7df9af2ca5c5e22782ddb Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Fri, 5 May 2017 10:52:55 +0530
Subject: [PATCH 11/37] qcacld-3.0: Initialize add_ie while updating scan ie

Initialize add_ie to false to avoid the possibility of
using add_ie with random value.

Change-Id: Ic2a4dfee2961220f853e674c3dfe90707377bf24
CRs-Fixed: 2042711
---
 core/hdd/src/wlan_hdd_scan.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/core/hdd/src/wlan_hdd_scan.c b/core/hdd/src/wlan_hdd_scan.c
index 617827b..4b3a8de 100644
--- a/core/hdd/src/wlan_hdd_scan.c
+++ b/core/hdd/src/wlan_hdd_scan.c
@@ -1508,7 +1508,7 @@ static int wlan_hdd_update_scan_ies(hdd_adapter_t *adapter,
 	uint8_t *current_ie;
 	uint8_t elem_id;
 	uint16_t elem_len;
-	bool add_ie;
+	bool add_ie = false;
 
 	if (!scan_info->default_scan_ies_len || !scan_info->default_scan_ies)
 		return 0;
-- 
1.7.9.5


From 2ec17e9fff3e2934a9f2904c963e150d3c058523 Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Thu, 4 May 2017 11:23:07 +0530
Subject: [PATCH 12/37] qcacld-3.0: Update ignore_assoc_disallowed while
 creating PE session

For MBO[Multi-Band Operations], supplicant configures driver to ignore
assocition disallowed even if assoc disallowed attribute is present
in MBO IE of target BSS. Currently driver is updating this config
in PE session and fails if PE session doesnot exist at the instance.

Save ignore_assoc_disallowed config to csr roam session and update the
same to PE session while creating it via sme join request.

Change-Id: I0379c756f6150533723ba4306f9780e345c3f61f
CRs-Fixed: 2042550
---
 core/mac/inc/sir_api.h                             |    2 +-
 core/mac/src/pe/lim/lim_process_sme_req_messages.c |    3 +++
 core/sme/inc/csr_internal.h                        |    1 +
 core/sme/src/common/sme_api.c                      |    3 +++
 core/sme/src/csr/csr_api_roam.c                    |    2 ++
 5 files changed, 10 insertions(+), 1 deletion(-)

diff --git a/core/mac/inc/sir_api.h b/core/mac/inc/sir_api.h
index 4408ea4..c0fb924 100644
--- a/core/mac/inc/sir_api.h
+++ b/core/mac/inc/sir_api.h
@@ -1267,7 +1267,7 @@ typedef struct sSirSmeJoinReq {
 #endif
 	/* Pls make this as last variable in struct */
 	tSirBssDescription bssDescription;
-
+	bool ignore_assoc_disallowed;
 } tSirSmeJoinReq, *tpSirSmeJoinReq;
 
 /* / Definition for reponse message to previously issued join request */
diff --git a/core/mac/src/pe/lim/lim_process_sme_req_messages.c b/core/mac/src/pe/lim/lim_process_sme_req_messages.c
index a9a279e..27176e8 100644
--- a/core/mac/src/pe/lim/lim_process_sme_req_messages.c
+++ b/core/mac/src/pe/lim/lim_process_sme_req_messages.c
@@ -1646,6 +1646,9 @@ __lim_process_sme_join_req(tpAniSirGlobal mac_ctx, uint32_t *msg_buf)
 		session->limQosEnabled = sme_join_req->isQosEnabled;
 		session->wps_registration = sme_join_req->wps_registration;
 
+		/* Update supplicant configured ignore assoc disallowed */
+		session->ignore_assoc_disallowed =
+				sme_join_req->ignore_assoc_disallowed;
 		/* Store vendor specfic IE for CISCO AP */
 		ie_len = (bss_desc->length + sizeof(bss_desc->length) -
 			 GET_FIELD_OFFSET(tSirBssDescription, ieFields));
diff --git a/core/sme/inc/csr_internal.h b/core/sme/inc/csr_internal.h
index 99689b8..26cf8d1 100644
--- a/core/sme/inc/csr_internal.h
+++ b/core/sme/inc/csr_internal.h
@@ -982,6 +982,7 @@ typedef struct tagCsrRoamSession {
 	qdf_mc_timer_t roaming_offload_timer;
 	bool is_fils_connection;
 	uint16_t fils_seq_num;
+	bool ignore_assoc_disallowed;
 } tCsrRoamSession;
 
 typedef struct tagCsrRoamStruct {
diff --git a/core/sme/src/common/sme_api.c b/core/sme/src/common/sme_api.c
index dad4d68..f77b35f 100644
--- a/core/sme/src/common/sme_api.c
+++ b/core/sme/src/common/sme_api.c
@@ -8358,6 +8358,9 @@ QDF_STATUS sme_update_session_param(tHalHandle hal, uint8_t session_id,
 			return status;
 		}
 
+		if (param_type == SIR_PARAM_IGNORE_ASSOC_DISALLOWED)
+			session->ignore_assoc_disallowed = param_val;
+
 		if (!session->sessionActive)
 			QDF_ASSERT(0);
 
diff --git a/core/sme/src/csr/csr_api_roam.c b/core/sme/src/csr/csr_api_roam.c
index 97c59a1..17ef247 100644
--- a/core/sme/src/csr/csr_api_roam.c
+++ b/core/sme/src/csr/csr_api_roam.c
@@ -15175,6 +15175,8 @@ QDF_STATUS csr_send_join_req_msg(tpAniSirGlobal pMac, uint32_t sessionId,
 				break;
 			}
 		}
+		csr_join_req->ignore_assoc_disallowed =
+					pSession->ignore_assoc_disallowed;
 		status = cds_send_mb_message_to_mac(csr_join_req);
 		if (!QDF_IS_STATUS_SUCCESS(status)) {
 			/*
-- 
1.7.9.5


From 8fb3641c55ca05ea3d2363c4f29869e2b400737c Mon Sep 17 00:00:00 2001
From: Prakash Dhavali <pdhavali@codeaurora.org>
Date: Wed, 24 May 2017 23:56:41 -0700
Subject: [PATCH 13/37] Release 5.1.2.1A

Release 5.1.2.1A

Change-Id: If9a14275fbd4be2459cd01b9dca9c1fbc3554401
CRs-Fixed: 774533
---
 core/mac/inc/qwlan_version.h |    8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

diff --git a/core/mac/inc/qwlan_version.h b/core/mac/inc/qwlan_version.h
index 3b6ac49..1f440d5 100644
--- a/core/mac/inc/qwlan_version.h
+++ b/core/mac/inc/qwlan_version.h
@@ -40,10 +40,10 @@
 
 #define QWLAN_VERSION_MAJOR            5
 #define QWLAN_VERSION_MINOR            1
-#define QWLAN_VERSION_PATCH            1
-#define QWLAN_VERSION_EXTRA            "P"
-#define QWLAN_VERSION_BUILD            15
+#define QWLAN_VERSION_PATCH            2
+#define QWLAN_VERSION_EXTRA            "A"
+#define QWLAN_VERSION_BUILD            1
 
-#define QWLAN_VERSIONSTR               "5.1.1.15P"
+#define QWLAN_VERSIONSTR               "5.1.2.1A"
 
 #endif /* QWLAN_VERSION_H */
-- 
1.7.9.5


From c7ef017ab5c37c3a97bd4bfcec8d1995daea5873 Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Fri, 26 May 2017 19:32:05 +0530
Subject: [PATCH 14/37] qcacld-3.0: Parse beacon IE's to extract Fixed fields

Currently, in beacon IE parsing of roam synch indication, fixed fields
[beacon interval, timestamp, capabilities] are not parsed resulting
in these fields being reported as zeros to supplicant.

Parse beacon IE's to extract fixed fields from beacon IE's.

Change-Id: I3ba2b8037de99a49b42eeecc7670bdb23c118f9d
CRs-Fixed: 2053019
---
 core/mac/src/include/parser_api.h                  |   13 ++++++
 core/mac/src/pe/lim/lim_api.c                      |   33 +++++++++++++++
 core/mac/src/sys/legacy/src/utils/src/parser_api.c |   42 ++++++++++----------
 3 files changed, 68 insertions(+), 20 deletions(-)

diff --git a/core/mac/src/include/parser_api.h b/core/mac/src/include/parser_api.h
index 38d9c2a..52d200e 100644
--- a/core/mac/src/include/parser_api.h
+++ b/core/mac/src/include/parser_api.h
@@ -1114,5 +1114,18 @@ sir_validate_and_rectify_ies(tpAniSirGlobal mac_ctx,
 				uint8_t *mgmt_frame,
 				uint32_t frame_bytes,
 				uint32_t *missing_rsn_bytes);
+/**
+ * sir_copy_caps_info() - Copy Caps info from tDot11fFfCapabilities to
+ *                        beacon/probe response structure.
+ * @mac_ctx: MAC Context
+ * @caps: tDot11fFfCapabilities structure
+ * @pProbeResp: beacon/probe response structure
+ *
+ * Copy the caps info to beacon/probe response structure
+ *
+ * Return: None
+ */
+void sir_copy_caps_info(tpAniSirGlobal mac_ctx, tDot11fFfCapabilities caps,
+			tpSirProbeRespBeacon pProbeResp);
 
 #endif /* __PARSE_H__ */
diff --git a/core/mac/src/pe/lim/lim_api.c b/core/mac/src/pe/lim/lim_api.c
index fce4d13..ce5327d 100644
--- a/core/mac/src/pe/lim/lim_api.c
+++ b/core/mac/src/pe/lim/lim_api.c
@@ -1746,6 +1746,30 @@ void lim_fill_join_rsp_ht_caps(tpPESession session, tpSirSmeJoinRsp join_rsp)
 }
 #endif
 
+/**
+ * sir_parse_bcn_fixed_fields() - Parse fixed fields in Beacon IE's
+ *
+ * @mac_ctx: MAC Context
+ * @beacon_struct: Beacon/Probe Response structure
+ * @buf: Fixed Fields buffer
+ */
+static void sir_parse_bcn_fixed_fields(tpAniSirGlobal mac_ctx,
+					tpSirProbeRespBeacon beacon_struct,
+					uint8_t *buf)
+{
+	tDot11fFfCapabilities dst;
+	beacon_struct->timeStamp[0] = lim_get_u32(buf);
+	beacon_struct->timeStamp[1] = lim_get_u32(buf + 4);
+	buf += 8;
+
+	beacon_struct->beaconInterval = lim_get_u16(buf);
+	buf += 2;
+
+	dot11f_unpack_ff_capabilities(mac_ctx, buf, &dst);
+
+	sir_copy_caps_info(mac_ctx, dst, beacon_struct);
+}
+
 #ifdef WLAN_FEATURE_ROAM_OFFLOAD
 static QDF_STATUS
 lim_roam_fill_bss_descr(tpAniSirGlobal pMac,
@@ -1802,6 +1826,15 @@ lim_roam_fill_bss_descr(tpAniSirGlobal pMac,
 			return QDF_STATUS_E_FAILURE;
 		}
 	}
+
+	/*
+	 * For probe response, unpack core parses beacon interval, capabilities,
+	 * timestamp. For beacon IEs, these fields are not parsed.
+	 */
+	if (roam_offload_synch_ind_ptr->isBeacon)
+		sir_parse_bcn_fixed_fields(pMac, parsed_frm_ptr,
+			&bcn_proberesp_ptr[SIR_MAC_HDR_LEN_3A]);
+
 	/* 24 byte MAC header and 12 byte to ssid IE */
 	if (roam_offload_synch_ind_ptr->beaconProbeRespLength >
 		(SIR_MAC_HDR_LEN_3A + SIR_MAC_B_PR_SSID_OFFSET)) {
diff --git a/core/mac/src/sys/legacy/src/utils/src/parser_api.c b/core/mac/src/sys/legacy/src/utils/src/parser_api.c
index b111a44..73c38a8 100644
--- a/core/mac/src/sys/legacy/src/utils/src/parser_api.c
+++ b/core/mac/src/sys/legacy/src/utils/src/parser_api.c
@@ -2366,6 +2366,27 @@ sir_convert_fils_data_to_probersp_struct(tpSirProbeRespBeacon probe_resp,
 }
 #endif
 
+void sir_copy_caps_info(tpAniSirGlobal mac_ctx, tDot11fFfCapabilities caps,
+					    tpSirProbeRespBeacon pProbeResp)
+{
+	pProbeResp->capabilityInfo.ess = caps.ess;
+	pProbeResp->capabilityInfo.ibss = caps.ibss;
+	pProbeResp->capabilityInfo.cfPollable = caps.cfPollable;
+	pProbeResp->capabilityInfo.cfPollReq = caps.cfPollReq;
+	pProbeResp->capabilityInfo.privacy = caps.privacy;
+	pProbeResp->capabilityInfo.shortPreamble = caps.shortPreamble;
+	pProbeResp->capabilityInfo.pbcc = caps.pbcc;
+	pProbeResp->capabilityInfo.channelAgility =	caps.channelAgility;
+	pProbeResp->capabilityInfo.spectrumMgt = caps.spectrumMgt;
+	pProbeResp->capabilityInfo.qos = caps.qos;
+	pProbeResp->capabilityInfo.shortSlotTime = caps.shortSlotTime;
+	pProbeResp->capabilityInfo.apsd = caps.apsd;
+	pProbeResp->capabilityInfo.rrm = caps.rrm;
+	pProbeResp->capabilityInfo.dsssOfdm = caps.dsssOfdm;
+	pProbeResp->capabilityInfo.delayedBA = caps.delayedBA;
+	pProbeResp->capabilityInfo.immediateBA = caps.immediateBA;
+}
+
 tSirRetStatus sir_convert_probe_frame2_struct(tpAniSirGlobal pMac,
 					      uint8_t *pFrame,
 					      uint32_t nFrame,
@@ -2407,26 +2428,7 @@ tSirRetStatus sir_convert_probe_frame2_struct(tpAniSirGlobal pMac,
 	/* Beacon Interval */
 	pProbeResp->beaconInterval = pr->BeaconInterval.interval;
 
-	/* Capabilities */
-	pProbeResp->capabilityInfo.ess = pr->Capabilities.ess;
-	pProbeResp->capabilityInfo.ibss = pr->Capabilities.ibss;
-	pProbeResp->capabilityInfo.cfPollable = pr->Capabilities.cfPollable;
-	pProbeResp->capabilityInfo.cfPollReq = pr->Capabilities.cfPollReq;
-	pProbeResp->capabilityInfo.privacy = pr->Capabilities.privacy;
-	pProbeResp->capabilityInfo.shortPreamble =
-		pr->Capabilities.shortPreamble;
-	pProbeResp->capabilityInfo.pbcc = pr->Capabilities.pbcc;
-	pProbeResp->capabilityInfo.channelAgility =
-		pr->Capabilities.channelAgility;
-	pProbeResp->capabilityInfo.spectrumMgt = pr->Capabilities.spectrumMgt;
-	pProbeResp->capabilityInfo.qos = pr->Capabilities.qos;
-	pProbeResp->capabilityInfo.shortSlotTime =
-		pr->Capabilities.shortSlotTime;
-	pProbeResp->capabilityInfo.apsd = pr->Capabilities.apsd;
-	pProbeResp->capabilityInfo.rrm = pr->Capabilities.rrm;
-	pProbeResp->capabilityInfo.dsssOfdm = pr->Capabilities.dsssOfdm;
-	pProbeResp->capabilityInfo.delayedBA = pr->Capabilities.delayedBA;
-	pProbeResp->capabilityInfo.immediateBA = pr->Capabilities.immediateBA;
+	sir_copy_caps_info(pMac, pr->Capabilities, pProbeResp);
 
 	if (!pr->SSID.present) {
 		pe_warn("Mandatory IE SSID not present!");
-- 
1.7.9.5


From 2073d47c111e9f3311c2d2c39da08ef246529922 Mon Sep 17 00:00:00 2001
From: Kapil Gupta <kapgupta@codeaurora.org>
Date: Mon, 29 May 2017 17:29:45 +0530
Subject: [PATCH 15/37] qcacld-3.0: Change MBO IE size to support no pref
 channel list

Current MBO IE size is limited to 6 byte except length which
is not enough to contain non preferred channel list.

Add changes to increase MBO IE size.

Change-Id: I9250e7ffc8085dfe39ac62f92a831ff8d3685406
CRs-Fixed: 2053589
---
 core/mac/src/cfg/cfgUtil/dot11f.frms               |    2 +-
 core/mac/src/include/dot11f.h                      |    8 +++----
 core/mac/src/sys/legacy/src/utils/src/dot11f.c     |   24 ++++++++++----------
 core/mac/src/sys/legacy/src/utils/src/parser_api.c |   18 +++++++--------
 4 files changed, 26 insertions(+), 26 deletions(-)

diff --git a/core/mac/src/cfg/cfgUtil/dot11f.frms b/core/mac/src/cfg/cfgUtil/dot11f.frms
index 07167ec..dd281a1 100644
--- a/core/mac/src/cfg/cfgUtil/dot11f.frms
+++ b/core/mac/src/cfg/cfgUtil/dot11f.frms
@@ -2450,7 +2450,7 @@ IE TimeAdvertisement (EID_TIME_ADVERTISEMENT)   // 8.4.2.63
 IE MBO_IE (EID_VENDOR_SPECIFIC) OUI ( 0x50, 0x6F, 0x9A, 0x16 )
 {
     mbo_cap[3];
-    assoc_disallowed[0..3];
+    variable_data[0..252];
 }
 
 IE QCN_IE (EID_VENDOR_SPECIFIC) OUI ( 0x8C, 0xFD, 0xF0, 0x01 )
diff --git a/core/mac/src/include/dot11f.h b/core/mac/src/include/dot11f.h
index e31733b..64518f9 100644
--- a/core/mac/src/include/dot11f.h
+++ b/core/mac/src/include/dot11f.h
@@ -35,7 +35,7 @@
  *
  *
  * This file was automatically generated by 'framesc'
- * Tue May  9 13:47:22 2017 from the following file(s):
+ * Mon May 29 15:47:41 2017 from the following file(s):
  *
  * dot11f.frms
  *
@@ -4799,8 +4799,8 @@ uint32_t dot11f_get_packed_ie_LinkIdentifier(
 typedef struct sDot11fIEMBO_IE {
 	uint8_t             present;
 	uint8_t             mbo_cap[3];
-	uint8_t             num_assoc_disallowed;
-	uint8_t             assoc_disallowed[3];
+	uint8_t             num_variable_data;
+	uint8_t             variable_data[252];
 } tDot11fIEMBO_IE;
 
 #define DOT11F_EID_MBO_IE (221)
@@ -4808,7 +4808,7 @@ typedef struct sDot11fIEMBO_IE {
 /* N.B. These #defines do *not* include the EID & length */
 #define DOT11F_IE_MBO_IE_MIN_LEN (7)
 
-#define DOT11F_IE_MBO_IE_MAX_LEN (10)
+#define DOT11F_IE_MBO_IE_MAX_LEN (259)
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/core/mac/src/sys/legacy/src/utils/src/dot11f.c b/core/mac/src/sys/legacy/src/utils/src/dot11f.c
index bc0fc22..0703ccc 100644
--- a/core/mac/src/sys/legacy/src/utils/src/dot11f.c
+++ b/core/mac/src/sys/legacy/src/utils/src/dot11f.c
@@ -33,7 +33,7 @@
  *
  *
  * This file was automatically generated by 'framesc'
- * Tue May  9 13:47:22 2017 from the following file(s):
+ * Mon May 29 15:47:41 2017 from the following file(s):
  *
  * dot11f.frms
  *
@@ -3469,13 +3469,13 @@ uint32_t dot11f_unpack_ie_MBO_IE(tpAniSirGlobal pCtx,
 	DOT11F_MEMCPY(pCtx, pDst->mbo_cap, pBuf, 3);
 	pBuf += 3;
 	ielen -= (uint8_t)3;
-	pDst->num_assoc_disallowed = (uint8_t)(ielen);
-	if (ielen > 3) {
+	pDst->num_variable_data = (uint8_t)(ielen);
+	if (ielen > 252) {
 		pDst->present = 0;
 		return DOT11F_SKIPPED_BAD_IE;
 	}
 
-	DOT11F_MEMCPY(pCtx, pDst->assoc_disallowed, pBuf, (ielen));
+	DOT11F_MEMCPY(pCtx, pDst->variable_data, pBuf, (ielen));
 	(void)pCtx;
 	return status;
 } /* End dot11f_unpack_ie_MBO_IE. */
@@ -6644,7 +6644,7 @@ static const tIEDefn IES_AssocRequest[] = {
 	0, 7, 9, SigIehs20vendor_ie, {80, 111, 154, 16, 0},
 	4, DOT11F_EID_HS20VENDOR_IE, 0, 0, },
 	{ offsetof(tDot11fAssocRequest, MBO_IE), offsetof(tDot11fIEMBO_IE,
-	present), 0, "MBO_IE", 0, 9, 12, SigIeMBO_IE, {80, 111, 154, 22, 0},
+	present), 0, "MBO_IE", 0, 9, 261, SigIeMBO_IE, {80, 111, 154, 22, 0},
 	4, DOT11F_EID_MBO_IE, 0, 0, },
 	{ offsetof(tDot11fAssocRequest, QCN_IE), offsetof(tDot11fIEQCN_IE,
 	present), 0, "QCN_IE", 0, 10, 10, SigIeQCN_IE, {140, 253, 240, 1, 0},
@@ -7066,7 +7066,7 @@ static const tIEDefn IES_Beacon[] = {
 	present), 0, "ESEVersion", 0, 7, 7, SigIeESEVersion, {0, 64, 150, 3, 0},
 	4, DOT11F_EID_ESEVERSION, 0, 0, },
 	{ offsetof(tDot11fBeacon, MBO_IE), offsetof(tDot11fIEMBO_IE, present), 0,
-	"MBO_IE", 0, 9, 12, SigIeMBO_IE, {80, 111, 154, 22, 0},
+	"MBO_IE", 0, 9, 261, SigIeMBO_IE, {80, 111, 154, 22, 0},
 	4, DOT11F_EID_MBO_IE, 0, 0, },
 	{ offsetof(tDot11fBeacon, QCN_IE), offsetof(tDot11fIEQCN_IE, present), 0,
 	"QCN_IE", 0, 10, 10, SigIeQCN_IE, {140, 253, 240, 1, 0},
@@ -7482,7 +7482,7 @@ static const tIEDefn IES_BeaconIEs[] = {
 	0, 7, 7, SigIeQComVendorIE, {0, 160, 198, 0, 0},
 	3, DOT11F_EID_QCOMVENDORIE, 0, 0, },
 	{ offsetof(tDot11fBeaconIEs, MBO_IE), offsetof(tDot11fIEMBO_IE, present),
-	0, "MBO_IE", 0, 9, 12, SigIeMBO_IE, {80, 111, 154, 22, 0},
+	0, "MBO_IE", 0, 9, 261, SigIeMBO_IE, {80, 111, 154, 22, 0},
 	4, DOT11F_EID_MBO_IE, 0, 0, },
 	{ offsetof(tDot11fBeaconIEs, QCN_IE), offsetof(tDot11fIEQCN_IE, present),
 	0, "QCN_IE", 0, 10, 10, SigIeQCN_IE, {140, 253, 240, 1, 0},
@@ -8106,7 +8106,7 @@ static const tIEDefn IES_ProbeResponse[] = {
 	0, 7, 7, SigIeESEVersion, {0, 64, 150, 3, 0},
 	4, DOT11F_EID_ESEVERSION, 0, 0, },
 	{ offsetof(tDot11fProbeResponse, MBO_IE), offsetof(tDot11fIEMBO_IE,
-	present), 0, "MBO_IE", 0, 9, 12, SigIeMBO_IE, {80, 111, 154, 22, 0},
+	present), 0, "MBO_IE", 0, 9, 261, SigIeMBO_IE, {80, 111, 154, 22, 0},
 	4, DOT11F_EID_MBO_IE, 0, 0, },
 	{ offsetof(tDot11fProbeResponse, QCN_IE), offsetof(tDot11fIEQCN_IE,
 	present), 0, "QCN_IE", 0, 10, 10, SigIeQCN_IE, {140, 253, 240, 1, 0},
@@ -13269,7 +13269,7 @@ static uint32_t get_packed_size_core(tpAniSirGlobal pCtx,
 					offset = sizeof(tDot11fIEMBO_IE);
 					byteCount = ((tDot11fIEMBO_IE *)
 					  (pFrm + pIe->offset + offset * i))->
-					  num_assoc_disallowed + 3;
+					  num_variable_data + 3;
 					pIePresent = ((tDot11fIEMBO_IE *)
 					  (pFrm + pIe->offset + offset * i))->
 					  present;
@@ -18321,7 +18321,7 @@ uint32_t dot11f_pack_ie_MBO_IE(tpAniSirGlobal pCtx,
 	uint8_t *pIeLen = 0;
 	uint32_t nConsumedOnEntry = *pnConsumed;
 	uint32_t nNeeded = 0U;
-	nNeeded  +=  (pSrc->num_assoc_disallowed + 3);
+	nNeeded  +=  (pSrc->num_variable_data + 3);
 	while (pSrc->present) {
 		if (nNeeded > nBuf)
 			return DOT11F_BUFFER_OVERFLOW;
@@ -18340,8 +18340,8 @@ uint32_t dot11f_pack_ie_MBO_IE(tpAniSirGlobal pCtx,
 		DOT11F_MEMCPY(pCtx, pBuf, pSrc->mbo_cap, 3);
 		*pnConsumed += 3;
 		pBuf += 3;
-		DOT11F_MEMCPY(pCtx, pBuf, &(pSrc->assoc_disallowed), pSrc->num_assoc_disallowed);
-		*pnConsumed += pSrc->num_assoc_disallowed;
+		DOT11F_MEMCPY(pCtx, pBuf, &(pSrc->variable_data), pSrc->num_variable_data);
+		*pnConsumed += pSrc->num_variable_data;
 		/* fieldsEndFlag = 1 */
 		break;
 	}
diff --git a/core/mac/src/sys/legacy/src/utils/src/parser_api.c b/core/mac/src/sys/legacy/src/utils/src/parser_api.c
index 73c38a8..8739085 100644
--- a/core/mac/src/sys/legacy/src/utils/src/parser_api.c
+++ b/core/mac/src/sys/legacy/src/utils/src/parser_api.c
@@ -2637,12 +2637,12 @@ tSirRetStatus sir_convert_probe_frame2_struct(tpAniSirGlobal pMac,
 		pProbeResp->MBO_IE_present = true;
 		pProbeResp->MBO_capability = pr->MBO_IE.mbo_cap[2];
 
-		if (pr->MBO_IE.num_assoc_disallowed &&
-			(pr->MBO_IE.assoc_disallowed[0] ==
+		if (pr->MBO_IE.num_variable_data &&
+			(pr->MBO_IE.variable_data[0] ==
 				 MBO_IE_ASSOC_DISALLOWED_SUBATTR_ID)) {
 			pProbeResp->assoc_disallowed = true;
 			pProbeResp->assoc_disallowed_reason =
-				pr->MBO_IE.assoc_disallowed[2];
+				pr->MBO_IE.variable_data[2];
 		}
 	}
 
@@ -3908,12 +3908,12 @@ sir_parse_beacon_ie(tpAniSirGlobal pMac,
 		pBeaconStruct->MBO_IE_present = true;
 		pBeaconStruct->MBO_capability = pBies->MBO_IE.mbo_cap[2];
 
-		if (pBies->MBO_IE.num_assoc_disallowed &&
-			(pBies->MBO_IE.assoc_disallowed[0] ==
+		if (pBies->MBO_IE.num_variable_data &&
+			(pBies->MBO_IE.variable_data[0] ==
 				 MBO_IE_ASSOC_DISALLOWED_SUBATTR_ID)) {
 			pBeaconStruct->assoc_disallowed = true;
 			pBeaconStruct->assoc_disallowed_reason =
-				pBies->MBO_IE.assoc_disallowed[2];
+				pBies->MBO_IE.variable_data[2];
 		}
 	}
 
@@ -4297,12 +4297,12 @@ sir_convert_beacon_frame2_struct(tpAniSirGlobal pMac,
 		pBeaconStruct->MBO_IE_present = true;
 		pBeaconStruct->MBO_capability = pBeacon->MBO_IE.mbo_cap[2];
 
-		if (pBeacon->MBO_IE.num_assoc_disallowed &&
-			(pBeacon->MBO_IE.assoc_disallowed[0] ==
+		if (pBeacon->MBO_IE.num_variable_data &&
+			(pBeacon->MBO_IE.variable_data[0] ==
 				 MBO_IE_ASSOC_DISALLOWED_SUBATTR_ID)) {
 			pBeaconStruct->assoc_disallowed = true;
 			pBeaconStruct->assoc_disallowed_reason =
-				pBeacon->MBO_IE.assoc_disallowed[2];
+				pBeacon->MBO_IE.variable_data[2];
 		}
 	}
 
-- 
1.7.9.5


From 197b91f54bb1eee3fd442323843b16ce10537410 Mon Sep 17 00:00:00 2001
From: Prakash Dhavali <pdhavali@codeaurora.org>
Date: Tue, 30 May 2017 13:33:33 -0700
Subject: [PATCH 16/37] Release 5.1.2.1B

Release 5.1.2.1B

Change-Id: I2be3cec4ad21403f77f4c9e48e19b38438bb83ea
CRs-Fixed: 774533
---
 core/mac/inc/qwlan_version.h |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/core/mac/inc/qwlan_version.h b/core/mac/inc/qwlan_version.h
index 1f440d5..89ee080 100644
--- a/core/mac/inc/qwlan_version.h
+++ b/core/mac/inc/qwlan_version.h
@@ -41,9 +41,9 @@
 #define QWLAN_VERSION_MAJOR            5
 #define QWLAN_VERSION_MINOR            1
 #define QWLAN_VERSION_PATCH            2
-#define QWLAN_VERSION_EXTRA            "A"
+#define QWLAN_VERSION_EXTRA            "B"
 #define QWLAN_VERSION_BUILD            1
 
-#define QWLAN_VERSIONSTR               "5.1.2.1A"
+#define QWLAN_VERSIONSTR               "5.1.2.1B"
 
 #endif /* QWLAN_VERSION_H */
-- 
1.7.9.5


From e07f1f553ed49af296df8ab925880fb3641f986f Mon Sep 17 00:00:00 2001
From: Manjunathappa Prakash <prakashpm@codeaurora.org>
Date: Thu, 11 May 2017 22:17:04 -0700
Subject: [PATCH 17/37] qcacld-3.0: revert back ol_rx_add_mpdu_to_list to
 macro

Changes done to head pointer in ol_rx_add_mpdu_to_list() is not
returned back to caller as arguments are sent as pass by value

Change-Id: Ie8c98af2ea4e03b0678df243aa0c832165494168
CRs-Fixed: 2046362
---
 core/dp/txrx/ol_rx_pn.c |   26 +++++++++++---------------
 1 file changed, 11 insertions(+), 15 deletions(-)

diff --git a/core/dp/txrx/ol_rx_pn.c b/core/dp/txrx/ol_rx_pn.c
index c387ea7..e15877d 100644
--- a/core/dp/txrx/ol_rx_pn.c
+++ b/core/dp/txrx/ol_rx_pn.c
@@ -36,19 +36,15 @@
 #include <ol_rx.h>              /* ol_rx_deliver */
 
 /* add the MSDUs from this MPDU to the list of good frames */
-static void ol_rx_add_mpdu_to_list(qdf_nbuf_t head,
-				   qdf_nbuf_t tail,
-				   qdf_nbuf_t mpdu,
-				   qdf_nbuf_t mpdu_tail)
-{
-	do {
-		if (!head)
-			head = mpdu;
-		else
-			qdf_nbuf_set_next(tail, mpdu);
-		tail = mpdu_tail;
-	} while (0);
-}
+#define ADD_MPDU_TO_LIST(head, tail, mpdu, mpdu_tail) do {		\
+		if (!head) {						\
+			head = mpdu;					\
+		} else {						\
+			qdf_nbuf_set_next(tail, mpdu);			\
+		}							\
+		tail = mpdu_tail;					\
+	} while (0)
+
 int ol_rx_pn_cmp24(union htt_rx_pn_t *new_pn,
 		   union htt_rx_pn_t *old_pn, int is_unicast, int opmode)
 {
@@ -131,7 +127,7 @@ ol_rx_pn_check_base(struct ol_txrx_vdev_t *vdev,
 
 		/* Don't check the PN replay for non-encrypted frames */
 		if (!htt_rx_mpdu_is_encrypted(pdev->htt_pdev, rx_desc)) {
-			ol_rx_add_mpdu_to_list(out_list_head, out_list_tail,
+			ADD_MPDU_TO_LIST(out_list_head, out_list_tail,
 					       mpdu, mpdu_tail);
 			mpdu = next_mpdu;
 			continue;
@@ -226,7 +222,7 @@ ol_rx_pn_check_base(struct ol_txrx_vdev_t *vdev,
 				msdu = next_msdu;
 			} while (1);
 		} else {
-			ol_rx_add_mpdu_to_list(out_list_head, out_list_tail,
+			ADD_MPDU_TO_LIST(out_list_head, out_list_tail,
 					       mpdu, mpdu_tail);
 			/*
 			 * Remember the new PN.
-- 
1.7.9.5


From a43c58ff76e72c8b3dbd86a0ea7a2f3a081a700e Mon Sep 17 00:00:00 2001
From: Prakash Dhavali <pdhavali@codeaurora.org>
Date: Wed, 31 May 2017 16:14:40 -0700
Subject: [PATCH 18/37] Release 5.1.2.2

Release 5.1.2.2

Change-Id: I56998409e1e27189133eb3410623cc8869caf3e4
CRs-Fixed: 774533
---
 core/mac/inc/qwlan_version.h |    6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

diff --git a/core/mac/inc/qwlan_version.h b/core/mac/inc/qwlan_version.h
index 89ee080..96fe129 100644
--- a/core/mac/inc/qwlan_version.h
+++ b/core/mac/inc/qwlan_version.h
@@ -41,9 +41,9 @@
 #define QWLAN_VERSION_MAJOR            5
 #define QWLAN_VERSION_MINOR            1
 #define QWLAN_VERSION_PATCH            2
-#define QWLAN_VERSION_EXTRA            "B"
-#define QWLAN_VERSION_BUILD            1
+#define QWLAN_VERSION_EXTRA            ""
+#define QWLAN_VERSION_BUILD            2
 
-#define QWLAN_VERSIONSTR               "5.1.2.1B"
+#define QWLAN_VERSIONSTR               "5.1.2.2"
 
 #endif /* QWLAN_VERSION_H */
-- 
1.7.9.5


From 802d77382285cf0dea995fee07a707ae8c86a2da Mon Sep 17 00:00:00 2001
From: "Selvaraj, Sridhar" <sselvara@codeaurora.org>
Date: Thu, 8 Jun 2017 12:21:39 +0530
Subject: [PATCH 19/37] qcacld-3.0: Keep bssDescription at the end of
 tSirSmeJoinReq struct

Move bssDescription to the end of tSirSmeJoinReq since bssDescription
has ieFields at its end which would be corrupted if we dont keep it
at the end of bssDescription. This results in not detecting the IE's
properly after assoc response processing, not setting wpa_rsn flag
in PEER_ASSOC_CMD to fw. The subsequent LFR3 roam if happens in fw
fails because of this.

Keep bssDescription at the end of tSirSmeJoinReq struct.

Change-Id: I7096f7da0a475b0c63078f3c77fba240a41dfb00
CRs-Fixed: 2058223
---
 core/mac/inc/sir_api.h |    9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

diff --git a/core/mac/inc/sir_api.h b/core/mac/inc/sir_api.h
index c0fb924..41c39f3 100644
--- a/core/mac/inc/sir_api.h
+++ b/core/mac/inc/sir_api.h
@@ -1265,9 +1265,14 @@ typedef struct sSirSmeJoinReq {
 #ifdef WLAN_FEATURE_FILS_SK
 	struct cds_fils_connection_info fils_con_info;
 #endif
-	/* Pls make this as last variable in struct */
-	tSirBssDescription bssDescription;
 	bool ignore_assoc_disallowed;
+	bool enable_bcast_probe_rsp;
+	tSirBssDescription bssDescription;
+	/*
+	 * WARNING: Pls make bssDescription as last variable in struct
+	 * tSirSmeJoinReq as it has ieFields followed after this bss
+	 * description. Adding a variable after this corrupts the ieFields
+	 */
 } tSirSmeJoinReq, *tpSirSmeJoinReq;
 
 /* / Definition for reponse message to previously issued join request */
-- 
1.7.9.5


From 0b59a26fb20af4206e70ab339a919774f5346558 Mon Sep 17 00:00:00 2001
From: Abhishek Singh <absingh@codeaurora.org>
Date: Fri, 16 Jun 2017 14:14:36 +0530
Subject: [PATCH 20/37] qcacld-3.0: Set proper sec channel offset if CSA Wide
 BW IE is present

If CSA Wide BW IE is present the sec channel offset is always set to
csa_params->sec_chan_offset which is always 0 and thus for next CSA the
BW will always be set to 20 MHz.

To fix this set proper sec channel offset if CSA Wide BW IE is present.

Change-Id: I813b04683cbce3f4f933562c23511de92ce4bcef
CRs-Fixed: 2062475
---
 core/mac/src/pe/lim/lim_send_sme_rsp_messages.c |   11 ++++++++++-
 core/mac/src/pe/lim/lim_utils.c                 |    4 ++--
 2 files changed, 12 insertions(+), 3 deletions(-)

diff --git a/core/mac/src/pe/lim/lim_send_sme_rsp_messages.c b/core/mac/src/pe/lim/lim_send_sme_rsp_messages.c
index 505c66c..7f783f3 100644
--- a/core/mac/src/pe/lim/lim_send_sme_rsp_messages.c
+++ b/core/mac/src/pe/lim/lim_send_sme_rsp_messages.c
@@ -2179,7 +2179,16 @@ void lim_handle_csa_offload_msg(tpAniSirGlobal mac_ctx, tpSirMsgQ msg)
 			lim_process_csa_wbw_ie(mac_ctx, csa_params,
 					chnl_switch_info, session_entry);
 			lim_ch_switch->sec_ch_offset =
-				csa_params->sec_chan_offset;
+				PHY_SINGLE_CHANNEL_CENTERED;
+			if (chnl_switch_info->newChanWidth) {
+				if (csa_params->channel <
+				  csa_params->new_ch_freq_seg1)
+					lim_ch_switch->sec_ch_offset =
+						PHY_DOUBLE_CHANNEL_LOW_PRIMARY;
+				else
+					lim_ch_switch->sec_ch_offset =
+						PHY_DOUBLE_CHANNEL_HIGH_PRIMARY;
+			}
 		} else if (csa_params->ies_present_flag
 				& lim_xcsa_ie_present) {
 			chan_space =
diff --git a/core/mac/src/pe/lim/lim_utils.c b/core/mac/src/pe/lim/lim_utils.c
index 03fbbf4..790a229 100644
--- a/core/mac/src/pe/lim/lim_utils.c
+++ b/core/mac/src/pe/lim/lim_utils.c
@@ -2753,7 +2753,6 @@ void lim_switch_primary_secondary_channel(tpAniSirGlobal pMac,
 					uint8_t ch_center_freq_seg1,
 					enum phy_ch_width ch_width)
 {
-	uint8_t subband = 0;
 
 	/* Assign the callback to resume TX once channel is changed. */
 	psessionEntry->currentReqChannel = newChannel;
@@ -2777,7 +2776,8 @@ void lim_switch_primary_secondary_channel(tpAniSirGlobal pMac,
 	if (psessionEntry->htSecondaryChannelOffset !=
 			psessionEntry->gLimChannelSwitch.sec_ch_offset) {
 		pe_warn("switch old sec chnl: %d --> new sec chnl: %d",
-			psessionEntry->htSecondaryChannelOffset, subband);
+			psessionEntry->htSecondaryChannelOffset,
+			psessionEntry->gLimChannelSwitch.sec_ch_offset);
 		psessionEntry->htSecondaryChannelOffset =
 			psessionEntry->gLimChannelSwitch.sec_ch_offset;
 		if (psessionEntry->htSecondaryChannelOffset ==
-- 
1.7.9.5


From 0b7c98707e3244c8212fbdfc01365827c0d4b7cd Mon Sep 17 00:00:00 2001
From: Abhishek Singh <absingh@codeaurora.org>
Date: Tue, 27 Jun 2017 17:30:06 +0530
Subject: [PATCH 21/37] qcacld-3.0: Use vht operation or opmode to change the
 VHT channel width

Even if vht operation or Opmode IE is present in beacon, HT info IE is used to
detect the channel width and set to firmware and then again vht operation or
opmode IE is used to detect and set new channel width to firmware.

So if vht operation or Opmode IE are present, use them to detect and set
new channel width.

Change-Id: Ibbb5a2c55a5f79536fe269e0b6c0f5ff2c369309
CRs-Fixed: 2067727
---
 core/mac/src/pe/sch/sch_beacon_process.c |    9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

diff --git a/core/mac/src/pe/sch/sch_beacon_process.c b/core/mac/src/pe/sch/sch_beacon_process.c
index f02d6bd..8b2fd18 100644
--- a/core/mac/src/pe/sch/sch_beacon_process.c
+++ b/core/mac/src/pe/sch/sch_beacon_process.c
@@ -748,8 +748,13 @@ static void __sch_beacon_process_for_session(tpAniSirGlobal mac_ctx,
 			return;
 	}
 
-	if (session->htCapability && bcn->HTInfo.present &&
-			!LIM_IS_IBSS_ROLE(session))
+	/*
+	 * For vht session, if opermode ie or vht oper IE is present
+	 * bandwidth change will be taken care using these vht IEs.
+	 */
+	if (!(session->vhtCapability && (bcn->OperatingMode.present ||
+	   bcn->VHTOperation.present)) && session->htCapability &&
+	   bcn->HTInfo.present && !LIM_IS_IBSS_ROLE(session))
 		lim_update_sta_run_time_ht_switch_chnl_params(mac_ctx,
 						&bcn->HTInfo, bssIdx, session);
 
-- 
1.7.9.5


From 05b35a86753f7701a61fb4eb81b43c36a6c891fb Mon Sep 17 00:00:00 2001
From: Deepak Dhamdhere <ddhamdhe@codeaurora.org>
Date: Sat, 24 Jun 2017 11:46:00 -0700
Subject: [PATCH 22/37] qcacld-3.0: Send multiple beacon report frames if
 needed

RRM beacon report scan may find many neighbor BSSIDs on a channel
but it currently sends only 1 beacon report frame with maximum 4
measurement reports. Add a loop to go send all BSSIDs by generating
multiple frames.

CRs-Fixed: 2065920
Change-Id: Iabf889e092b4818ca9c31969eea38e92028209c0
---
 core/mac/src/pe/rrm/rrm_api.c |   23 ++++++++++++++++++-----
 1 file changed, 18 insertions(+), 5 deletions(-)

diff --git a/core/mac/src/pe/rrm/rrm_api.c b/core/mac/src/pe/rrm/rrm_api.c
index 39dcc25..2a5497b 100644
--- a/core/mac/src/pe/rrm/rrm_api.c
+++ b/core/mac/src/pe/rrm/rrm_api.c
@@ -761,6 +761,7 @@ rrm_process_beacon_report_xmit(tpAniSirGlobal mac_ctx,
 	tpPESession session_entry;
 	uint8_t session_id, counter;
 	uint8_t bss_desc_count = 0;
+	uint8_t report_index = 0;
 
 	pe_debug("Received beacon report xmit indication");
 
@@ -874,12 +875,24 @@ rrm_process_beacon_report_xmit(tpAniSirGlobal mac_ctx,
 				break;
 			}
 		}
-		pe_info("Sending Action frame with %d bss info",
-			bss_desc_count);
-		lim_send_radio_measure_report_action_frame(mac_ctx,
-			curr_req->dialog_token, bss_desc_count, report,
-			beacon_xmit_ind->bssId, session_entry);
 
+		/*
+		 * Each frame can hold RADIO_REPORTS_MAX_IN_A_FRAME reports.
+		 * Multiple frames may be sent if bss_desc_count is larger.
+		 */
+		while (report_index < bss_desc_count) {
+			int m_count;
+
+			m_count = min((bss_desc_count - report_index),
+					RADIO_REPORTS_MAX_IN_A_FRAME);
+			pe_info("Sending Action frame with %d bss info",
+				m_count);
+			lim_send_radio_measure_report_action_frame(mac_ctx,
+				curr_req->dialog_token, m_count,
+				&report[report_index],
+				beacon_xmit_ind->bssId, session_entry);
+			report_index += m_count;
+		}
 		curr_req->sendEmptyBcnRpt = false;
 	}
 
-- 
1.7.9.5


From 178b7ea0fbd4c561564a386a8e21aabc0d408493 Mon Sep 17 00:00:00 2001
From: Prakash Dhavali <pdhavali@codeaurora.org>
Date: Wed, 28 Jun 2017 17:50:26 -0700
Subject: [PATCH 23/37] Release 5.1.2.3

Release 5.1.2.3

Change-Id: I2cd60c6c66690cf539e5c882cfa790d3909374a9
CRs-Fixed: 774533
---
 core/mac/inc/qwlan_version.h |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/core/mac/inc/qwlan_version.h b/core/mac/inc/qwlan_version.h
index 96fe129..f726794 100644
--- a/core/mac/inc/qwlan_version.h
+++ b/core/mac/inc/qwlan_version.h
@@ -42,8 +42,8 @@
 #define QWLAN_VERSION_MINOR            1
 #define QWLAN_VERSION_PATCH            2
 #define QWLAN_VERSION_EXTRA            ""
-#define QWLAN_VERSION_BUILD            2
+#define QWLAN_VERSION_BUILD            3
 
-#define QWLAN_VERSIONSTR               "5.1.2.2"
+#define QWLAN_VERSIONSTR               "5.1.2.3"
 
 #endif /* QWLAN_VERSION_H */
-- 
1.7.9.5


From e48b3429b41c486d64f3304e2310b66da33e05dc Mon Sep 17 00:00:00 2001
From: Ravi Joshi <ravij@codeaurora.org>
Date: Mon, 1 May 2017 13:31:34 -0700
Subject: [PATCH 24/37] qcacld-3.0: Fix regression in nan data iface creation

Fix recent regression while creating nan data interface.

Change-Id: I106f3f1f673bcb6d89d592fbde10e52974ef4c4a
CRs-Fixed: 2041012
---
 core/hdd/src/wlan_hdd_nan_datapath.c |    4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/core/hdd/src/wlan_hdd_nan_datapath.c b/core/hdd/src/wlan_hdd_nan_datapath.c
index d1c4a83..2e2e147 100644
--- a/core/hdd/src/wlan_hdd_nan_datapath.c
+++ b/core/hdd/src/wlan_hdd_nan_datapath.c
@@ -873,10 +873,12 @@ static void hdd_ndp_iface_create_rsp_handler(hdd_adapter_t *adapter,
 		hdd_err("failed to allocate memory");
 		return;
 	}
-	if (wlan_hdd_validate_context(hdd_ctx))
+
+	if (wlan_hdd_validate_context(hdd_ctx)) {
 		/* No way the driver can send response back to user space */
 		qdf_mem_free(roam_info);
 		return;
+	}
 
 	if (ndi_rsp) {
 		create_status = ndi_rsp->status;
-- 
1.7.9.5


From 596b50802f9f51b76cc8d29b9ff3b2e23211a564 Mon Sep 17 00:00:00 2001
From: Naveen Rawat <naveenrawat@codeaurora.org>
Date: Fri, 5 May 2017 17:33:32 -0700
Subject: [PATCH 25/37] qcacld-3.0: Fix NDI create crash

When NDI create and delete are repeated multiple times NDI create
crash second times due to MC thread getting stuck in infinite loop
within function csr_scan_append_bss_description. This function is
not applicable for NDI profile type. This patch fixes this by avoiding
csr_scan_append_bss_description for NDI mode.

Change-Id: If63068e214fa546f1ed015a99ed5b2f95298b39b
CRs-Fixed: 2044704
---
 core/sme/src/csr/csr_api_roam.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/core/sme/src/csr/csr_api_roam.c b/core/sme/src/csr/csr_api_roam.c
index 17ef247..788d026 100644
--- a/core/sme/src/csr/csr_api_roam.c
+++ b/core/sme/src/csr/csr_api_roam.c
@@ -6642,7 +6642,7 @@ static void csr_roam_process_start_bss_success(tpAniSirGlobal mac_ctx,
 			return;
 		}
 	}
-	if (!CSR_IS_INFRA_AP(profile)) {
+	if (!CSR_IS_INFRA_AP(profile) && !CSR_IS_NDI(profile)) {
 		scan_res =
 			csr_scan_append_bss_description(mac_ctx,
 					bss_desc, ies_ptr,
-- 
1.7.9.5


From 60d11a3db29366dd9090b9542d8b60583283e08a Mon Sep 17 00:00:00 2001
From: Ravi Joshi <ravij@codeaurora.org>
Date: Thu, 18 May 2017 16:28:54 -0700
Subject: [PATCH 26/37] qcacld-3.0: Fix stability issue while freeing NDI
 session

It is better to follow 2 stage sequence for NAN as well like
1) open adapter 2) start adapter (sme_open_session). Since that
is not possible making hdd_init_nan_data_mode happens at the end
when all adapters registered.

Change-Id: Ib67a8f8e9ee5546a77d90d04f0a69a2a5a739e4d
CRs-Fixed: 2049177
---
 core/hdd/src/wlan_hdd_main.c |   14 ++++++++------
 1 file changed, 8 insertions(+), 6 deletions(-)

diff --git a/core/hdd/src/wlan_hdd_main.c b/core/hdd/src/wlan_hdd_main.c
index 5a97be5..5df0359 100644
--- a/core/hdd/src/wlan_hdd_main.c
+++ b/core/hdd/src/wlan_hdd_main.c
@@ -3336,11 +3336,6 @@ hdd_adapter_t *hdd_open_adapter(hdd_context_t *hdd_ctx, uint8_t session_type,
 
 		adapter->device_mode = session_type;
 
-		if (QDF_NDI_MODE == session_type) {
-			status = hdd_init_nan_data_mode(adapter);
-			if (QDF_STATUS_SUCCESS != status)
-				goto err_free_netdev;
-		}
 
 		/* initialize action frame random mac info */
 		hdd_adapter_init_action_frame_random_mac(adapter);
@@ -3371,8 +3366,15 @@ hdd_adapter_t *hdd_open_adapter(hdd_context_t *hdd_ctx, uint8_t session_type,
 		wlan_hdd_netif_queue_control(adapter,
 					WLAN_STOP_ALL_NETIF_QUEUE_N_CARRIER,
 					WLAN_CONTROL_PATH);
-		break;
 
+		/* Initialize NAN Data Interface */
+		if (QDF_NDI_MODE == session_type) {
+			status = hdd_init_nan_data_mode(adapter);
+			if (QDF_STATUS_SUCCESS != status)
+				goto err_free_netdev;
+		}
+
+		break;
 
 	case QDF_P2P_GO_MODE:
 	case QDF_SAP_MODE:
-- 
1.7.9.5


From 56f7e73a91d0db1aa778005392e45acec5a4a221 Mon Sep 17 00:00:00 2001
From: Ravi Joshi <ravij@codeaurora.org>
Date: Sat, 20 May 2017 09:58:44 -0700
Subject: [PATCH 27/37] qcacld-3.0: Check NAN iface with same name before
 creating another one

There were some corner cases reported in which NDIs are getting
created with same name. Providing fix for the same.

Change-Id: I84ea80580faa44809e257d3b17645808637b5d51
CRs-Fixed: 2050050
---
 core/hdd/src/wlan_hdd_nan_datapath.c |    9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

diff --git a/core/hdd/src/wlan_hdd_nan_datapath.c b/core/hdd/src/wlan_hdd_nan_datapath.c
index 2e2e147..c5aebe6 100644
--- a/core/hdd/src/wlan_hdd_nan_datapath.c
+++ b/core/hdd/src/wlan_hdd_nan_datapath.c
@@ -320,6 +320,13 @@ static int hdd_ndi_create_req_handler(hdd_context_t *hdd_ctx,
 	transaction_id =
 		nla_get_u16(tb[QCA_WLAN_VENDOR_ATTR_NDP_TRANSACTION_ID]);
 
+	/* check for an existing NDI with the same name */
+	adapter = hdd_get_adapter_by_iface_name(hdd_ctx, iface_name);
+	if (adapter) {
+		hdd_err("NAN data interface %s is available", iface_name);
+		return -EEXIST;
+	}
+
 	adapter = hdd_open_adapter(hdd_ctx, QDF_NDI_MODE, iface_name,
 			wlan_hdd_get_intf_addr(hdd_ctx), NET_NAME_UNKNOWN,
 			true);
@@ -398,7 +405,7 @@ static int hdd_ndi_delete_req_handler(hdd_context_t *hdd_ctx,
 	adapter = hdd_get_adapter_by_iface_name(hdd_ctx, iface_name);
 	if (!adapter) {
 		hdd_err("NAN data interface %s is not available", iface_name);
-		return -EINVAL;
+		return -ENODEV;
 	}
 
 	/* check if adapter is in NDI mode */
-- 
1.7.9.5


From 99193c382f5f1479e4055d5fca2b9a0449dadc0e Mon Sep 17 00:00:00 2001
From: Ravi Joshi <ravij@codeaurora.org>
Date: Tue, 6 Jun 2017 23:37:42 -0700
Subject: [PATCH 28/37] qcacld-3.0: Fix transaction id descrepancy during NDI
 create

Driver truncated the transaction id to 8-bits from 16-bit
value causing the descrepancy in transaction id exchange
during NDI create.

CRs-Fixed: 2057476
Change-Id: I502f422620411c39bd0e75f06e9b7200bfea24ae
---
 core/hdd/src/wlan_hdd_nan_datapath.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/core/hdd/src/wlan_hdd_nan_datapath.c b/core/hdd/src/wlan_hdd_nan_datapath.c
index c5aebe6..0df0510 100644
--- a/core/hdd/src/wlan_hdd_nan_datapath.c
+++ b/core/hdd/src/wlan_hdd_nan_datapath.c
@@ -865,7 +865,7 @@ static void hdd_ndp_iface_create_rsp_handler(hdd_adapter_t *adapter,
 				NLMSG_HDRLEN + (4 * NLA_HDRLEN);
 	struct nan_datapath_ctx *ndp_ctx = WLAN_HDD_GET_NDP_CTX_PTR(adapter);
 	bool create_fail = false;
-	uint8_t create_transaction_id = 0;
+	uint16_t create_transaction_id = 0;
 	uint32_t create_status = NDP_RSP_STATUS_ERROR;
 	uint32_t create_reason = NDP_NAN_DATA_IFACE_CREATE_FAILED;
 	hdd_station_ctx_t *sta_ctx = WLAN_HDD_GET_STATION_CTX_PTR(adapter);
-- 
1.7.9.5


From 23b518a422506f7f033091aa71d5fff933d02537 Mon Sep 17 00:00:00 2001
From: Ravi Joshi <ravij@codeaurora.org>
Date: Thu, 1 Jun 2017 13:26:09 -0700
Subject: [PATCH 29/37] qcacld-3.0: Configure scan burst duration when NDI is
 active

Configure burst duration for the scan when VDEV is in NDI mode
and at least one peer is connected.

CRs-Fixed: 2055300
Change-Id: I4cd582ad8df6bc2aa2095cff1933b2f9d166fd60
---
 core/wma/src/wma_nan_datapath.h |   21 +++++++++++++++++++++
 core/wma/src/wma_scan_roam.c    |    9 +++++++++
 2 files changed, 30 insertions(+)

diff --git a/core/wma/src/wma_nan_datapath.h b/core/wma/src/wma_nan_datapath.h
index 30187d6..d65c2b1 100644
--- a/core/wma/src/wma_nan_datapath.h
+++ b/core/wma/src/wma_nan_datapath.h
@@ -48,6 +48,25 @@ static inline void wma_update_hdd_cfg_ndp(tp_wma_handle wma_handle,
 {
 	tgt_cfg->nan_datapath_enabled = wma_handle->nan_datapath_enabled;
 }
+
+/**
+ * wma_is_ndi_active() - Determines of the nan data iface is active
+ * @wma_handle: handle to wma context
+ *
+ * Returns: true if ndi active, flase otherwise
+ */
+static inline bool wma_is_ndi_active(tp_wma_handle wma_handle)
+{
+	int i;
+
+	for (i = 0; i < wma_handle->max_bssid; i++) {
+		if (wma_handle->interfaces[i].type == WMI_VDEV_TYPE_NDI &&
+				wma_handle->interfaces[i].peer_count > 0)
+			return true;
+	}
+	return false;
+}
+
 QDF_STATUS wma_handle_ndp_responder_req(tp_wma_handle wma_handle,
 					struct ndp_responder_req *req_params);
 void wma_delete_all_nan_remote_peers(tp_wma_handle wma,
@@ -115,5 +134,7 @@ static inline uint32_t wma_ndp_get_eventid_from_tlvtag(uint32_t tag)
 {
 	return 0;
 }
+
+static inline bool wma_is_ndi_active(tp_wma_handle wma_handle) { return false; }
 #endif /* WLAN_FEATURE_NAN_DATAPATH */
 #endif /* __WMA_NAN_DATAPATH_H */
diff --git a/core/wma/src/wma_scan_roam.c b/core/wma/src/wma_scan_roam.c
index 9a83326..3fdb315 100644
--- a/core/wma/src/wma_scan_roam.c
+++ b/core/wma/src/wma_scan_roam.c
@@ -69,6 +69,7 @@
 
 #include "dfs.h"
 #include "wma_internal.h"
+#include "wma_nan_datapath.h"
 
 #define WMA_MCC_MIRACAST_REST_TIME 400
 #define WMA_SCAN_ID_MASK 0x0fff
@@ -390,6 +391,14 @@ QDF_STATUS wma_get_buf_start_scan_cmd(tp_wma_handle wma_handle,
 					cmd->burst_duration = 0;
 				break;
 			}
+			if (wma_is_ndi_active(wma_handle)) {
+				cmd->burst_duration = wma_get_burst_duration(
+						scan_req->maxChannelTime,
+						wma_handle->miracast_value);
+				WMA_LOGD("NDI Active, Burst duration: %x",
+					cmd->burst_duration);
+				break;
+			}
 		} while (0);
 
 	} else {
-- 
1.7.9.5


From c8326a4d08d1c53102bd17aa24af569d45bb58d6 Mon Sep 17 00:00:00 2001
From: Naveen Rawat <naveenrawat@codeaurora.org>
Date: Fri, 26 May 2017 11:46:05 -0700
Subject: [PATCH 30/37] qcacld-3.0: Randomize NDI mac address

Randomize NDI mac address and avoid potential conflict with FW's
generated NMI mac address by setting LSB of 6th byte to 0.

Change-Id: I8b194fb06bfd1abc46c40124c813a9880d631114
CRs-Fixed: 2053119
---
 core/hdd/src/wlan_hdd_nan_datapath.c |   51 ++++++++++++++++++++++++++++++++--
 1 file changed, 49 insertions(+), 2 deletions(-)

diff --git a/core/hdd/src/wlan_hdd_nan_datapath.c b/core/hdd/src/wlan_hdd_nan_datapath.c
index 0df0510..d770049 100644
--- a/core/hdd/src/wlan_hdd_nan_datapath.c
+++ b/core/hdd/src/wlan_hdd_nan_datapath.c
@@ -286,6 +286,48 @@ static int hdd_ndi_start_bss(hdd_adapter_t *adapter,
 	return ret;
 }
 
+/**
+ * hdd_get_random_nan_mac_addr() - generate random non pre-existent mac address
+ * @hdd_ctx: hdd context pointer
+ * @mac_addr: mac address buffer to populate
+ *
+ * Return: status of operation
+ */
+static int hdd_get_random_nan_mac_addr(hdd_context_t *hdd_ctx,
+				       struct qdf_mac_addr *mac_addr)
+{
+	hdd_adapter_t *adapter;
+	uint8_t i, attempts, max_attempt = 16;
+	struct qdf_mac_addr bcast_mac_addr = QDF_MAC_ADDR_BROADCAST_INITIALIZER;
+
+	for (attempts = 0; attempts < max_attempt; attempts++) {
+		cds_rand_get_bytes(0, (uint8_t *)mac_addr, sizeof(*mac_addr));
+		WLAN_HDD_RESET_LOCALLY_ADMINISTERED_BIT(mac_addr->bytes);
+		/*
+		 * to avoid potential conflict with FW's generated NMI mac addr,
+		 * host sets LSB if 6th byte to 0
+		 */
+		mac_addr->bytes[5] &= 0xFE;
+
+		if (!qdf_mem_cmp(mac_addr, &bcast_mac_addr, sizeof(*mac_addr)))
+			continue;
+
+		for (i = 0; i < QDF_MAX_CONCURRENCY_PERSONA; i++) {
+			if (!qdf_mem_cmp(hdd_ctx->config->intfMacAddr[i].bytes,
+					 mac_addr, sizeof(*mac_addr)))
+				continue;
+		}
+
+		adapter = hdd_get_adapter_by_macaddr(hdd_ctx, mac_addr->bytes);
+		if (!adapter)
+			return 0;
+	}
+
+	hdd_err("unable to get non-pre-existing mac address in %d attempts",
+		max_attempt);
+
+	return -EINVAL;
+}
 
 /**
  * hdd_ndi_create_req_handler() - NDI create request handler
@@ -304,6 +346,7 @@ static int hdd_ndi_create_req_handler(hdd_context_t *hdd_ctx,
 	struct nan_datapath_ctx *ndp_ctx;
 	uint8_t op_channel =
 		hdd_ctx->config->nan_datapath_ndi_channel;
+	struct qdf_mac_addr ndi_mac_addr;
 
 	ENTER();
 
@@ -327,9 +370,13 @@ static int hdd_ndi_create_req_handler(hdd_context_t *hdd_ctx,
 		return -EEXIST;
 	}
 
+	if (hdd_get_random_nan_mac_addr(hdd_ctx, &ndi_mac_addr)) {
+		hdd_err("get random mac address failed");
+		return -EINVAL;
+	}
+
 	adapter = hdd_open_adapter(hdd_ctx, QDF_NDI_MODE, iface_name,
-			wlan_hdd_get_intf_addr(hdd_ctx), NET_NAME_UNKNOWN,
-			true);
+				&ndi_mac_addr.bytes[0], NET_NAME_UNKNOWN, true);
 	if (!adapter) {
 		hdd_err("hdd_open_adapter failed");
 		return -ENOMEM;
-- 
1.7.9.5


From fc5efcfb2a2dc5d6980fa06b64f2e63a6bf513b1 Mon Sep 17 00:00:00 2001
From: Ravi Joshi <ravij@codeaurora.org>
Date: Sun, 11 Jun 2017 19:47:54 -0700
Subject: [PATCH 31/37] qcacld-3.0: Set LA bit and reset multicast bit in the
 mac addr

Locally administered bit needs to be set and multicast bit
needs to be reset in the interface/vdev mac address.

Change-Id: Ifdc39a8137617ebf2d09434deba13767f0c7cf34
CRs-Fixed: 2059150
---
 core/hdd/src/wlan_hdd_nan_datapath.c |   11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

diff --git a/core/hdd/src/wlan_hdd_nan_datapath.c b/core/hdd/src/wlan_hdd_nan_datapath.c
index d770049..bdfbed1 100644
--- a/core/hdd/src/wlan_hdd_nan_datapath.c
+++ b/core/hdd/src/wlan_hdd_nan_datapath.c
@@ -298,20 +298,21 @@ static int hdd_get_random_nan_mac_addr(hdd_context_t *hdd_ctx,
 {
 	hdd_adapter_t *adapter;
 	uint8_t i, attempts, max_attempt = 16;
-	struct qdf_mac_addr bcast_mac_addr = QDF_MAC_ADDR_BROADCAST_INITIALIZER;
 
 	for (attempts = 0; attempts < max_attempt; attempts++) {
 		cds_rand_get_bytes(0, (uint8_t *)mac_addr, sizeof(*mac_addr));
-		WLAN_HDD_RESET_LOCALLY_ADMINISTERED_BIT(mac_addr->bytes);
+
+		/*
+		 * Reset multicast bit (bit-0) and set locally-administered bit
+		 */
+		mac_addr->bytes[0] = 0x2;
+
 		/*
 		 * to avoid potential conflict with FW's generated NMI mac addr,
 		 * host sets LSB if 6th byte to 0
 		 */
 		mac_addr->bytes[5] &= 0xFE;
 
-		if (!qdf_mem_cmp(mac_addr, &bcast_mac_addr, sizeof(*mac_addr)))
-			continue;
-
 		for (i = 0; i < QDF_MAX_CONCURRENCY_PERSONA; i++) {
 			if (!qdf_mem_cmp(hdd_ctx->config->intfMacAddr[i].bytes,
 					 mac_addr, sizeof(*mac_addr)))
-- 
1.7.9.5


From c2259962c5dca570bfb7619979b26d348e26d43a Mon Sep 17 00:00:00 2001
From: Ravi Joshi <ravij@codeaurora.org>
Date: Thu, 4 May 2017 19:54:45 -0700
Subject: [PATCH 32/37] qcacld-3.0: Fix cds_mc_thread getting stuck in
 infinite loop

A null IE in the bss entry was causing a busyloop in the
cds-mc-thread.

Change-Id: Ia8bc11f7ee31b2be48d6f1fd9cfb50bc6e49c0c3
CRs-Fixed: 2043510
---
 core/sme/src/csr/csr_api_scan.c |    6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

diff --git a/core/sme/src/csr/csr_api_scan.c b/core/sme/src/csr/csr_api_scan.c
index 61b8863..c1908f6 100644
--- a/core/sme/src/csr/csr_api_scan.c
+++ b/core/sme/src/csr/csr_api_scan.c
@@ -7258,8 +7258,12 @@ void csr_init_occupied_channels_list(tpAniSirGlobal pMac, uint8_t sessionId)
 		/* At this time, pBssDescription->Result.pvIes may be NULL */
 		if (!pIes && !QDF_IS_STATUS_SUCCESS(
 			csr_get_parsed_bss_description_ies(pMac,
-				&pBssDesc->Result.BssDescriptor, &pIes)))
+				&pBssDesc->Result.BssDescriptor, &pIes))) {
+			/* Pick next bss entry before continuing */
+			pEntry = csr_ll_next(&pMac->scan.scanResultList, pEntry,
+				     LL_ACCESS_NOLOCK);
 			continue;
+		}
 		csr_scan_add_to_occupied_channels(pMac, pBssDesc, sessionId,
 				&pMac->scan.occupiedChannels[sessionId], pIes,
 				true);
-- 
1.7.9.5


From 900893268b221cc6dec04e55ee375c3983817539 Mon Sep 17 00:00:00 2001
From: Ravi Joshi <ravij@codeaurora.org>
Date: Sun, 7 May 2017 21:29:19 -0700
Subject: [PATCH 33/37] qcacld-3.0: Fix NAN peer addition/deletion with
 all-zero mac addr

NAN Enable/NAN Disable followed by NAN data request causes NDP to
fail. The failure is due to the firmware sending all-zero peer
mac address. Even though, FW should not be sending all-zero
peer address, the host should not attempt to add/delete such
a peer.

CRs-Fixed: 2043780
Change-Id: Ieab390d3fe4c585e1692767839856af2ad17a37b
---
 core/mac/src/pe/nan/nan_datapath.c |   16 ++++++++++++++++
 1 file changed, 16 insertions(+)

diff --git a/core/mac/src/pe/nan/nan_datapath.c b/core/mac/src/pe/nan/nan_datapath.c
index 765c11d..79e3cb8 100644
--- a/core/mac/src/pe/nan/nan_datapath.c
+++ b/core/mac/src/pe/nan/nan_datapath.c
@@ -77,13 +77,22 @@ static QDF_STATUS lim_add_ndi_peer(tpAniSirGlobal mac_ctx,
 	tpDphHashNode sta_ds;
 	uint16_t assoc_id, peer_idx;
 	tSirRetStatus status;
+	uint8_t zero_mac_addr[QDF_MAC_ADDR_SIZE] = { 0, 0, 0, 0, 0, 0 };
+
+	if (!qdf_mem_cmp(&zero_mac_addr, &peer_mac_addr.bytes[0],
+			QDF_MAC_ADDR_SIZE)) {
+		pe_err("Failing to add peer with all zero mac addr");
+		return QDF_STATUS_E_FAILURE;
+	}
 
 	session = pe_find_session_by_sme_session_id(mac_ctx,
 						vdev_id);
 	if (session == NULL) {
 		/* couldn't find session */
+		pe_err("Session not found for vdev_id: %d", vdev_id);
 		return QDF_STATUS_E_FAILURE;
 	}
+
 	sta_ds = dph_lookup_hash_entry(mac_ctx,
 				peer_mac_addr.bytes,
 				&assoc_id, &session->dph.dphHashTable);
@@ -233,6 +242,13 @@ void lim_ndp_delete_peer_by_addr(tpAniSirGlobal mac_ctx, uint8_t vdev_id,
 	tpPESession session;
 	tpDphHashNode sta_ds;
 	uint16_t peer_idx;
+	uint8_t zero_mac_addr[QDF_MAC_ADDR_SIZE] = { 0, 0, 0, 0, 0, 0 };
+
+	if (!qdf_mem_cmp(&zero_mac_addr, &peer_ndi_mac_addr.bytes[0],
+			QDF_MAC_ADDR_SIZE)) {
+		pe_err("Failing to delete the peer with all zero mac addr");
+		return;
+	}
 
 	pe_info("deleting peer: "MAC_ADDRESS_STR" confirm rejected",
 		MAC_ADDR_ARRAY(peer_ndi_mac_addr.bytes));
-- 
1.7.9.5


From fcef528b2b180c5f444273bd0bc9e29ed81e935d Mon Sep 17 00:00:00 2001
From: Ravi Joshi <ravij@codeaurora.org>
Date: Thu, 11 May 2017 16:34:25 -0700
Subject: [PATCH 34/37] qcacld-3.0: Allow nan data interface delete with peers
 attached

Service layer was not allowed to delete NDI if there are active
NDP sessions (peers). Service layer is expected to delete the
active NDP sessions before issuing NDI delete. However, that
is not guaranteed to happen. Hence allowing internal cleanup
to happen by allowing the command to firmware.

Change-Id: Iab9bc3bca431475792c164d16cdd18be2f346188
CRs-Fixed: 2046240
---
 core/hdd/src/wlan_hdd_nan_datapath.c |    6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

diff --git a/core/hdd/src/wlan_hdd_nan_datapath.c b/core/hdd/src/wlan_hdd_nan_datapath.c
index bdfbed1..d44cd7e 100644
--- a/core/hdd/src/wlan_hdd_nan_datapath.c
+++ b/core/hdd/src/wlan_hdd_nan_datapath.c
@@ -475,11 +475,9 @@ static int hdd_ndi_delete_req_handler(hdd_context_t *hdd_ctx,
 	}
 
 	/* check if there are active peers on the adapter */
-	if (ndp_ctx->active_ndp_peers > 0) {
-		hdd_err("NDP peers active: %d, cannot delete NDI",
+	if (ndp_ctx->active_ndp_peers > 0)
+		hdd_err("NDP peers active: %d, active NDPs may not terminated",
 			ndp_ctx->active_ndp_peers);
-		return -EINVAL;
-	}
 
 	/*
 	 * Since, the interface is being deleted, remove the
-- 
1.7.9.5


From a1b326d957e1bc7ee82823170d55a61f21bb2e9e Mon Sep 17 00:00:00 2001
From: bings <bings@codeaurora.org>
Date: Fri, 7 Jul 2017 11:31:42 +0800
Subject: [PATCH 35/37] qcacld-3.0: Fix sta re-association request short of
 PMKID

PMK caching wifi certification fails due to no PMKID information
in station re-association request with enterprise encryption.

When new pmk cache is gotten, we need check whether it is present.
Before comparing ssid, we need to be sure ssid length is valid.

Change-Id: I62de1afe84e89722d28de2fa93e16be946b89eb6
CRs-Fixed: 2072631
---
 core/sme/src/csr/csr_api_roam.c |    7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

diff --git a/core/sme/src/csr/csr_api_roam.c b/core/sme/src/csr/csr_api_roam.c
index 788d026..4e66b6f 100644
--- a/core/sme/src/csr/csr_api_roam.c
+++ b/core/sme/src/csr/csr_api_roam.c
@@ -13887,9 +13887,10 @@ QDF_STATUS csr_roam_del_pmkid_from_cache(tpAniSirGlobal pMac,
 				&pmksa->BSSID))
 			fMatchFound = 1;
 
-		else if ((!qdf_mem_cmp(cached_pmksa->ssid,
-			pmksa->ssid, pmksa->ssid_len)) &&
-			(!qdf_mem_cmp(cached_pmksa->cache_id,
+		else if (cached_pmksa->ssid_len &&
+				(!qdf_mem_cmp(cached_pmksa->ssid,
+				pmksa->ssid, pmksa->ssid_len)) &&
+				(!qdf_mem_cmp(cached_pmksa->cache_id,
 				pmksa->cache_id, CACHE_ID_LEN)))
 			fMatchFound = 1;
 
-- 
1.7.9.5


From 4c4ec73cec8d7b4ec38aaaf6221b1c30fff5b2f0 Mon Sep 17 00:00:00 2001
From: Kapil Gupta <kapgupta@codeaurora.org>
Date: Wed, 31 May 2017 18:55:16 +0530
Subject: [PATCH 36/37] qcacld-3.0: Enable LDPC for rome based targets

For Rome based targets, host doesn't get LDPC info in 2g and
5g capabilities info.

Add changes to check for LDPC flag in WMA handle for rome based
solutions.

Change-Id: I0b8ee82b457a27371a7c6f25f318246e31b56361
CRs-Fixed: 2054494
---
 core/wma/src/wma_main.c |   24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

diff --git a/core/wma/src/wma_main.c b/core/wma/src/wma_main.c
index 2909106..e54969d 100644
--- a/core/wma/src/wma_main.c
+++ b/core/wma/src/wma_main.c
@@ -5097,12 +5097,36 @@ bool wma_is_rx_ldpc_supported_for_channel(uint32_t channel,
 	struct wma_caps_per_phy caps_per_phy = {0};
 	enum cds_band_type band;
 	bool status;
+	t_wma_handle *wma_handle;
+	struct hif_target_info *tgt_info;
+	struct hif_opaque_softc *scn = cds_get_context(QDF_MODULE_ID_HIF);
+
+	if (!scn) {
+		WMA_LOGE("%s: Invalid wma handle", __func__);
+		return false;
+	}
 
 	if (!CDS_IS_CHANNEL_24GHZ(channel))
 		band = CDS_BAND_5GHZ;
 	else
 		band = CDS_BAND_2GHZ;
 
+	tgt_info = hif_get_target_info_handle(scn);
+
+	if ((tgt_info->target_type == TARGET_TYPE_AR6320V1) ||
+	    (tgt_info->target_type == TARGET_TYPE_AR6320V2) ||
+	    (tgt_info->target_type == TARGET_TYPE_AR6320V3) ||
+	    (tgt_info->target_type == TARGET_TYPE_QCA9377V1)) {
+		wma_handle = cds_get_context(QDF_MODULE_ID_WMA);
+		if (!wma_handle) {
+			WMA_LOGE("Invalid wma handle");
+			return false;
+		}
+		if (wma_handle->ht_cap_info & WMI_HT_CAP_LDPC)
+			return true;
+		else
+			return false;
+	}
 	if (QDF_STATUS_SUCCESS != wma_get_caps_for_phyidx_hwmode(
 						&caps_per_phy,
 						hw_mode, band)) {
-- 
1.7.9.5


From a79f25279f3d660977fb09b45347d59e77ecfbc4 Mon Sep 17 00:00:00 2001
From: Prakash Dhavali <pdhavali@codeaurora.org>
Date: Fri, 28 Jul 2017 01:38:37 -0700
Subject: [PATCH 37/37] Release 5.1.2.4A

Release 5.1.2.4A

NAN Release

Change-Id: Ibbcf3f083d875c345bdfc38903354248df8275fb
CRs-Fixed: 774533
---
 core/mac/inc/qwlan_version.h |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/core/mac/inc/qwlan_version.h b/core/mac/inc/qwlan_version.h
index f726794..2f6ec76 100644
--- a/core/mac/inc/qwlan_version.h
+++ b/core/mac/inc/qwlan_version.h
@@ -42,8 +42,8 @@
 #define QWLAN_VERSION_MINOR            1
 #define QWLAN_VERSION_PATCH            2
 #define QWLAN_VERSION_EXTRA            ""
-#define QWLAN_VERSION_BUILD            3
+#define QWLAN_VERSION_BUILD            4
 
-#define QWLAN_VERSIONSTR               "5.1.2.3"
+#define QWLAN_VERSIONSTR               "5.1.2.4"
 
 #endif /* QWLAN_VERSION_H */
-- 
1.7.9.5

